<?php

namespace Ems\Controllers;

use Exception\Messages;
use Service\LogService;
use Service\OAuth\OAuthCustomImpl;
use Zeedhi\Framework\Controller\Simple;
use Zeedhi\Framework\HTTP\Kernel;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Response\Error;
use Util\ControladorAlerta;


use Ems\Services\ApuracaoAdcNoturnoService;

class ApuracaoAdcNoturnoController {
    /** @var ApuracaoAdcNoturnoService */
    protected $apuracaoAdcNoturnoService;

    public function __construct(ApuracaoAdcNoturnoService $apuracaoAdcNoturnoService) {
        $this->apuracaoAdcNoturnoService = $apuracaoAdcNoturnoService;
    }

    public function apurarAutoAdcNoturno(
        Request\Row $request,
        Response $response
    ) { 
        try {
            $row = $request->getRow();
            $this->apuracaoAdcNoturnoService->apurarAutoAdcNoturno(
                $row
            );

            $dataset = [
                'success' => true
            ];

            $response->addDataSet(new DataSet('apurarAutoAdcNoturno', $dataset));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode()));
        }
    }
}
