<?php
namespace Ems\Repository;

use Doctrine\ORM\EntityManager;
use Doctrine\DBAL\Connection;
use Util\NovoCodigo;
use Ems\Util\Utilities;

class ComunicadoAcidenteTrabalhoRepository{
    protected $entityManager;
    protected $connection;

    public function __construct(
        EntityManager $entityManager
    ){
        $this->connection      = $entityManager->getConnection();
        $this->entityManager   = $entityManager;
    }

    public function getComunicadoAcidenteTrabalho(array $params): array {
        $sql = <<<SQL
            SELECT 
    OC.NRORG,
    OC.NROCORRENCIA,
    OC.NRESTRUTURAM,
    OC.NRTIPOOCORRE,
    OC.NRCLASSIFICACAO,
    OC.NRGRAVIDADE,
    OC.NRINFLUENCIAGERENCIAL,
    OC.NRCAUSA,
    OC.NRACAO,
    TO_CHAR(OC.DTHROCORRENCIA, 'DD/MM/YYYY') AS DTOCORRENCIA,
    TO_CHAR(OC.DTHROCORRENCIA, 'HH24:MI') AS HROCORRENCIA,
    OC.DTHRRELATOOCORRE,
    OC.DSTIPOOCORRE,
    OC.DSCLASSIFOCORRE,
    OC.DSOCORRENCIA,
    OC.IDOCORRENCIA,
    OC.QTVITIMASOCORRE,
    OC.DSOBSERVACAO AS DSOBERSVACAOOCO,
    OC.DSGRAVIDOCORRE,
    OC.DSINFLUGEROCORRE,
    
    TOC.NMTIPOOCORRE,
    EST.NMESTRUTURAM,
    CLA.NMCLASSIFICACAO,
    GRA.NMGRAVIDADE,
    INF_OC.NMINFLUENCIAGERENCIAL AS NMINFLUENCIAGERENCIAL,
    CA.NMCAUSA,
    AC.DSREFEACAO,
    TA.CDESOCIAL,

    VI.NRVITIMA,
    VI.NRNATUREZA,
    NA.NMNATUREZA,
    GRV.NMGRAVIDADE,
    VI.NRPARCNEGOCIO,
    VI.CDPAIS,
    VI.SGESTADO,
    VI.CDMUNICIPIO,
    VI.DSACIDENTE,
    VI.DSNATUREZAACID,
    VI.DSGRAVIDACID,
    VI.DSINFLUGERACID,
    SUBSTR(LPAD(VI.QTHRAPOSINICTRAB, 4, '0'), 1, 2) || ':' || SUBSTR(LPAD(VI.QTHRAPOSINICTRAB, 4, '0'), 3, 2) AS QTHRAPOSINICTRAB,
    TO_CHAR(VI.DTULTDIATRABALHADO, 'DD/MM/YYYY') AS DTULTDIATRABALHADO,
    VI.QTDIASDEBITADOS,
    VI.QTDIASPERDIDOS,
    VI.QTDIASTRABRESTRITO,
    VI.QTHRPERDIDAS,
    VI.IDACIDFATAL,
    VI.DTOBITO,
    VI.IDFALTAEPI,
    VI.IDAFASTAMENTO,
    VI.IDINTERNACAO,
    VI.IDREGPOLICIAL,
    VI.NRREGPOLICIAL,
    VI.IDINCAPACITADO,
    VI.DTHRINICATEND,
    TO_CHAR(VI.DTHRINICATEND, 'DD/MM/YYYY') AS DTINICATEND,
    TO_CHAR(VI.DTHRINICATEND, 'HH24:MI') AS HRINICATEND,
    SUBSTR(LPAD(VI.QTHRATEINICATEND, 4, '0'), 1, 2) || ':' || SUBSTR(LPAD(VI.QTHRATEINICATEND, 4, '0'), 3, 2) AS QTHRATEINICATEND,
    TO_CHAR(VI.DTHRFIMATEND, 'DD/MM/YYYY') AS DTFIMATEND,
    TO_CHAR(VI.DTHRFIMATEND, 'HH24:MI') AS HRFIMCATEND,
    SUBSTR(LPAD(VI.QTHRATENDIMENTO, 4, '0'), 1, 2) || ':' || SUBSTR(LPAD(VI.QTHRATENDIMENTO, 4, '0'), 3, 2) AS QTHRATENDIMENTO,
    
    VI.DTCAT,
    VI.NRCAT,
    VI.DSLOCALCAT,
    VI.DSOBSERVACAO AS DSOBSERVACAOVITIMA,
    VI.IDATIVO AS VI_IDATIVO,
    VI.NRORGINCLUSAO AS VI_NRORGINCLUSAO,
    VI.DTINCLUSAO AS VI_DTINCLUSAO,
    VI.CDOPERINCLUSAO AS VI_CDOPERINCLUSAO,
    VI.NRORGULTATU AS VI_NRORGULTATU,
    VI.DTULTATU AS VI_DTULTATU,
    VI.CDOPERULTATU AS VI_CDOPERULTATU,
    VI.NRTIPOLOCALCAT,
    TLC.DSTIPOLOCALCAT,
    VI.IDACIDENTEBIO,
    VI.DSPROFILAXIA,
    VI.NRCEPENDERECO,
    VI.NMBAIRROENDERECO,
    VI.CDLOGRADOURO,
    VI.DSENDERECO,
    VI.NRIMOVELENDERECO,
    VI.DSCOMPLEENDERECO,
    VI.DSREFERENCIAENDE,
    VI.NRAGENTCAUSAD,
    ACD.DSAGENTCAUSAD,
    PCN.NMPRINCIPALPARC,
    VI.NRCATORIGEM,
    VI.IDTIPOCAT,
    PA.NMPARTEATINGIDA,
    VPA.NRPARTEATINGIDA,
    VPA.LATERALIDADE,
    VPA.NRVITPARTEATING,
    VPA.DSDIAGNOSTICO,
    VPA.DSOBSERVACAO AS DSOBSERVACAOVPA,
    SFM.NRFICHAMEDICA,
    SFM.NRVINCULOM AS NRVINCULOMSFM,
    SFM.NRPARCNEGOCIO AS NRPARCNEGOCIOMEDICO,
    SFM.NRESTRUTURAM AS UNIDADEATENDIMENTO,
    SFM.NROCORRENCIA AS NROCORRENCIAFICHAMEDICA,
    SFM.NRINSCRCONSELHOATEND,
    SFM.DTCONCLFICHAMED,
    SFM.DTHRINIAFASTAMENTO,
    SFM.DTHRFIMAFASTAMENTO,
    PEFM.NRPESSOA,
    PHFM.NMPESSOA,
    DFM.NRCID,
    DFM.DSDOENCAFICHAMEDICA,
    DFM.IDOCUPACIONAL,
    DFM.NRDOENCAFICHAMEDICA,
    CID.DSCID,
    CID.CDCID,
    VM.NRVINCULOM, 
    VM.NMVINCULOM,
    VM.DTADMISSAOVINC,
    VM.DTRESCISAOVINC
FROM 
    SST_OCORRENCIA OC
LEFT JOIN 
    SST_TIPOOCORRE TOC
    ON OC.NRTIPOOCORRE = TOC.NRTIPOOCORRE
    AND OC.NRORG = TOC.NRORG
LEFT JOIN 
    ESTRUTURAM EST
    ON OC.NRESTRUTURAM = EST.NRESTRUTURAM
    AND OC.NRORG = EST.NRORG
LEFT JOIN 
    SST_CLASSIFICACAO CLA
    ON OC.NRCLASSIFICACAO = CLA.NRCLASSIFICACAO
    AND OC.NRORG = CLA.NRORG
LEFT JOIN 
    SST_GRAVIDADE GRA
    ON OC.NRGRAVIDADE = GRA.NRGRAVIDADE
    AND OC.NRORG = GRA.NRORG
LEFT JOIN 
    SST_INFLUENCIAGERENCIAL INF_OC
    ON OC.NRINFLUENCIAGERENCIAL = INF_OC.NRINFLUENCIAGERENCIAL
    AND OC.NRORG = INF_OC.NRORG
LEFT JOIN 
    SST_CAUSA CA
    ON OC.NRCAUSA = CA.NRCAUSA
    AND OC.NRORG = CA.NRORG
LEFT JOIN 
    ACAO AC
    ON OC.NRACAO = AC.NRACAO
    AND OC.NRORG = AC.NRORG
LEFT JOIN 
    SST_TIPOACIDENTE TA
    ON TA.NRTIPOACIDENTE = CLA.NRTIPOACIDENTE
    AND (TA.NRORG = CLA.NRORG OR TA.NRORG = :P_NRORG_PADRAO)
JOIN 
    SST_VITIMA VI
    ON OC.NROCORRENCIA = VI.NROCORRENCIA
    AND OC.NRORG = VI.NRORG
JOIN 
    PARCNEGOCIO PCN
    ON VI.NRPARCNEGOCIO = PCN.NRPARCNEGOCIO
    AND VI.NRORG = PCN.NRORG
 JOIN 
    GPE_PESSOA PE
    ON PE.NRPARCNEGOCIO = PCN.NRPARCNEGOCIO
    AND PE.NRORG = PCN.NRORG
 JOIN 
    GPE_PESSOAH PH
    ON PH.NRPESSOA = PE.NRPESSOA
    AND PH.NRORG = PE.NRORG
    AND PH.DTMESCOMPETENC = (
        SELECT DTMESCOMPETENC
        FROM (
            SELECT PH1.DTMESCOMPETENC
            FROM GPE_PESSOAH PH1
            WHERE PH1.NRPESSOA = PH.NRPESSOA
              AND PH1.NRORG = PH.NRORG
              AND PH1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
            ORDER BY PH1.DTMESCOMPETENC DESC
        )
        WHERE ROWNUM = 1
    )
JOIN 
    GPE_VINCULOM VM
    ON VM.NRORG = VI.NRORG
    AND VM.NRPESSOA = PE.NRPESSOA
    AND ( VM.DTRESCISAOVINC >= :P_DTMESCOMPETENC OR VM.DTRESCISAOVINC IS NULL )
    AND VM.DTADMISSAOVINC <= LAST_DAY(:P_DTMESCOMPETENC)
 JOIN 
    GPE_VINCULOH VH
    ON VH.NRORG = VI.NRORG
    AND VH.NRVINCULOM = VM.NRVINCULOM
    AND (INSTR(',' || :P_NRESTRUTGEREN || ',', ',' || VH.NRESTRUTGEREN || ',') > 0
                     OR :P_NRESTRUTGEREN IS NULL)
    AND VH.DTMESCOMPETENC = (
        SELECT DTMESCOMPETENC
        FROM (
            SELECT H1.DTMESCOMPETENC
            FROM GPE_VINCULOH H1
            WHERE H1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
              AND H1.NRORG = VM.NRORG
              AND H1.NRVINCULOM = VM.NRVINCULOM
            ORDER BY H1.DTMESCOMPETENC DESC
        )
        WHERE ROWNUM = 1
    )
LEFT JOIN 
    SST_NATUREZA NA
    ON VI.NRNATUREZA = NA.NRNATUREZA
    AND VI.NRORG = NA.NRORG
LEFT JOIN 
    SST_GRAVIDADE GRV
    ON VI.NRGRAVIDADE = GRV.NRGRAVIDADE
    AND VI.NRORG = GRV.NRORG
LEFT JOIN 
    SST_INFLUENCIAGERENCIAL INF_VI
    ON VI.NRINFLUENCIAGERENCIAL = INF_VI.NRINFLUENCIAGERENCIAL
    AND VI.NRORG = INF_VI.NRORG
LEFT JOIN 
    PAIS
    ON PAIS.CDPAIS = VI.CDPAIS
LEFT JOIN 
    ESTADO EST_VI
    ON EST_VI.SGESTADO = VI.SGESTADO
    AND PAIS.CDPAIS = EST_VI.CDPAIS
LEFT JOIN 
    MUNICIPIO MUN
    ON MUN.CDMUNICIPIO = VI.CDMUNICIPIO
    AND EST_VI.SGESTADO = MUN.SGESTADO
LEFT JOIN 
    SST_TIPOLOCALCAT TLC
    ON TLC.NRTIPOLOCALCAT = VI.NRTIPOLOCALCAT
LEFT JOIN 
    SST_AGENTCAUSAD ACD
    ON ACD.NRAGENTCAUSAD = VI.NRAGENTCAUSAD
LEFT JOIN SST_VITIMAPARTEATINGIDA VPA
    ON (OC.NRORG = VPA.NRORG
        OR OC.NRORG = :P_NRORG_PADRAO)
        AND VI.NRVITIMA = VPA.NRVITIMA
        AND OC.NROCORRENCIA = VPA.NROCORRENCIA
LEFT JOIN SST_PARTEATINGIDA PA
    ON VPA.NRPARTEATINGIDA = PA.NRPARTEATINGIDA
        AND (PA.NRORG = VPA.NRORG
        OR PA.NRORG = :P_NRORG_PADRAO)
LEFT JOIN 
    SST_FICHAMEDICA SFM
    ON SFM.NRORG = VI.NRORG
    AND SFM.NROCORRENCIA = VI.NROCORRENCIA
    AND SFM.NRVINCULOM = VM.NRVINCULOM
LEFT JOIN 
    (SELECT ESM.NRESTRUTURAM,
         ESH.NMESTRUTURAH,
         ESM.NRORG
    FROM ESTRUTURAM ESM
    INNER JOIN ESTRUTURAH ESH
        ON ESH.NRESTRUTURAM = ESM.NRESTRUTURAM
            AND ESM.NRORG = ESH.NRORG
    WHERE ESH.DTMESCOMPETENC IN 
        (SELECT MAX(ETH.DTMESCOMPETENC)
        FROM ESTRUTURAH ETH
        WHERE ETH.NRESTRUTURAM = ESM.NRESTRUTURAM
                AND ETH.NRORG = ESM.NRORG
                AND ETH.DTMESCOMPETENC <= :P_DTMESCOMPETENC )
                AND ESM.NRORG = :P_NRORG
                OR ESM.NRORG = :P_NRORG_PADRAO ) ETM
        ON ETM.NRESTRUTURAM = SFM.NRESTRUTURAM
        AND ETM.NRORG = SFM.NRORG
LEFT JOIN PARCNEGOCIO PCNFM
    ON PCNFM.NRORG = SFM.NRORG
        AND PCNFM.NRPARCNEGOCIO = SFM.NRPARCNEGOCIO
LEFT JOIN GPE_PESSOA PEFM
    ON PEFM.NRPARCNEGOCIO = PCNFM.NRPARCNEGOCIO
        AND PEFM.NRORG = PCNFM.NRORG
LEFT JOIN GPE_PESSOAH PHFM
    ON PHFM.NRPESSOA = PEFM.NRPESSOA
        AND PHFM.NRORG = PEFM.NRORG
        AND PHFM.DTMESCOMPETENC = 
    (SELECT DTMESCOMPETENC
    FROM 
        (SELECT PH1.DTMESCOMPETENC
        FROM GPE_PESSOAH PH1
        WHERE PH1.NRPESSOA = PHFM.NRPESSOA
                AND PH1.NRORG = PHFM.NRORG
                AND PH1.DTMESCOMPETENC <= :P_DTMESCOMPETENC
        ORDER BY  PH1.DTMESCOMPETENC DESC )
        WHERE ROWNUM = 1 )
LEFT JOIN SST_DOENCAFICHAMEDICA DFM
    ON OC.NRORG = DFM.NRORG
        AND SFM.NRFICHAMEDICA = DFM.NRFICHAMEDICA
LEFT JOIN SST_CID CID
    ON DFM.NRCID = CID.NRCID
LEFT JOIN GPE_CONSELHOREG ON ( GPE_CONSELHOREG.NRORG = PEFM.NRORG
                                               OR GPE_CONSELHOREG.NRORG = :P_NRORG_PADRAO )
                                             AND GPE_CONSELHOREG.NRCONSELHOREG = PHFM.NRCONSELHOREG
WHERE 
    ( OC.NRORG = :P_NRORG OR OC.NRORG = :P_NRORG_PADRAO )
    AND VI.NRVITIMA IS NOT NULL
SQL;
        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $cat = $std->fetchAll();

        return $cat;
    }

   public function setOcorrenciaCAT(array $rowDadosCAT, string $nrorg, $cdoperador)
    {   
        $nrOcorrencia = NovoCodigo::geraCodigo($nrorg, 'SST_OCORRENCIA', 1, 22, true);
        $sql = <<<SQL
            INSERT INTO SST_OCORRENCIA (
                NROCORRENCIA,
                NRORG,
                NRESTRUTURAM, 
                NRTIPOOCORRE, 
                NRCLASSIFICACAO, 
                NRGRAVIDADE, 
                NRINFLUENCIAGERENCIAL, 
                NRCAUSA, 
                NRACAO, 
                DTHROCORRENCIA, 
                DTHRRELATOOCORRE, 
                DSOCORRENCIA, 
                IDOCORRENCIA, 
                QTVITIMASOCORRE, 
                DSOBSERVACAO, 
                DSTIPOOCORRE, 
                DSCLASSIFOCORRE, 
                DSINFLUGEROCORRE,
                DSGRAVIDOCORRE,
                IDATIVO,
                NRORGINCLUSAO,
                DTINCLUSAO,
                CDOPERINCLUSAO,
                NRORGULTATU,
                DTULTATU,
                CDOPERULTATU
            ) VALUES (
                :P_NROCORRENCIA,
                :P_NRORG,
                :P_NRESTRUTURAM, 
                :P_NRTIPOOCORRE, 
                :P_NRCLASSIFICACAO, 
                :P_NRGRAVIDADE, 
                :P_NRINFLUENCIAGERENCIAL, 
                :P_NRCAUSA, 
                :P_NRACAO, 
                TO_DATE(:P_DTHROCORRENCIA,'DD/MM/YYYY HH24:MI:SS'),
                TO_DATE(:P_DTHRRELATOOCORRE,'DD/MM/YYYY HH24:MI:SS'),
                :P_DSOCORRENCIA, 
                :P_IDOCORRENCIA, 
                :P_QTVITIMASOCORRE, 
                :P_DSOBSERVACAO, 
                :P_DSTIPOOCORRE, 
                :P_DSCLASSIFOCORRE, 
                :P_DSINFLUGEROCORRE,
                :P_DSGRAVIDOCORRE,
                :P_IDATIVO,
                :P_NRORGINCLUSAO,
                TO_DATE(:P_DTINCLUSAO,'DD/MM/YYYY'),
                :P_CDOPERINCLUSAO,
                :P_NRORGULTATU,
                TO_DATE(:P_DTULTATU,'DD/MM/YYYY'),
                :P_CDOPERULTATU
            )
SQL;
    
        $params = [
            'P_NROCORRENCIA'           => $nrOcorrencia,
            'P_NRESTRUTURAM'           => $rowDadosCAT['NRESTRUTURAM']      ?? NULL,
            'P_NRORG'                  => $nrorg,
            'P_NRTIPOOCORRE'           => $rowDadosCAT['NRTIPOOCORRE'] ?? NULL,
            'P_NRCLASSIFICACAO'        => $rowDadosCAT['NRCLASSIFICACAO'] ?? NULL,
            'P_NRGRAVIDADE'            => $rowDadosCAT['NRGRAVIDADE'] ?? NULL,
            'P_NRINFLUENCIAGERENCIAL'  => $rowDadosCAT['NRINFLUENCIAGERENCIAL'] ?? NULL,
            'P_NRCAUSA'                => $rowDadosCAT['NRCAUSA'] ?? NULL,
            'P_NRACAO'                 => $rowDadosCAT['NRACAO'] ?? NULL,
            'P_DTHROCORRENCIA'         => $rowDadosCAT['DTHROCORRENCIAFORMAT'] ?? NULL,
            'P_DTHRRELATOOCORRE'       => $rowDadosCAT['DTHROCORRENCIAFORMAT']  ?? NULL,
            'P_DSOCORRENCIA'           => $rowDadosCAT['DSOCORRENCIA'] ?? NULL,
            'P_DSGRAVIDOCORRE'         => $rowDadosCAT['DSGRAVIDOCORRE'] ?? NULL,
            'P_IDOCORRENCIA'           => $rowDadosCAT['IDOCORRENCIA'] ?? NULL,
            'P_QTVITIMASOCORRE'        => $rowDadosCAT['QTVITIMASOCORRE'] ?? 1,
            'P_DSOBSERVACAO'           => $rowDadosCAT['DSOBERSVACAOOCO'] ?? NULL,
            'P_DSTIPOOCORRE'           => $rowDadosCAT['DSTIPOOCORRE'] ?? NULL,
            'P_DSCLASSIFOCORRE'        => $rowDadosCAT['DSCLASSIFOCORRE'] ?? NULL,
            'P_DSINFLUGEROCORRE'       => $rowDadosCAT['DSINFLUGEROCORRE'] ?? NULL,

            "P_IDATIVO"                => $rowDadosCAT['IDATIVO']         ??  'S' ,
            "P_NRORGINCLUSAO"          => $nrorg ,
            "P_DTINCLUSAO"             => $rowDadosCAT['DTINCLUSAO']     ??  NULL ,
            "P_CDOPERINCLUSAO"         => $cdoperador,
            "P_NRORGULTATU"            => $nrorg,
            "P_DTULTATU"               => $rowDadosCAT['DTULTATU']    ??       NULL ,
            "P_CDOPERULTATU"           => $cdoperador,
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $result = $query->execute($params);
        

        if($result === true) {
            return $nrOcorrencia;
        }
    }

    public function setVitima($rowDadosVitima, $nrorg, $rowDadosCAT, $nrOcorrencia, $cdoperador )
    {   
        $nrVitima = NovoCodigo::geraCodigo($nrorg, 'SST_VITIMA', 1, 22, true);
        $sql = <<<SQL
                INSERT INTO SST_VITIMA (
                NRVITIMA,
                NRORG,
                NRNATUREZA,
                NRGRAVIDADE,
                NRINFLUENCIAGERENCIAL,
                NROCORRENCIA,
                NRPARCNEGOCIO,
                CDPAIS,
                SGESTADO,
                CDMUNICIPIO,
                DSACIDENTE,
                DSNATUREZAACID,
                DSGRAVIDACID,
                DSINFLUGERACID,
                QTHRAPOSINICTRAB,
                DTULTDIATRABALHADO,
                QTDIASDEBITADOS,
                QTDIASPERDIDOS,
                QTDIASTRABRESTRITO,
                QTHRPERDIDAS,
                IDACIDFATAL,
                DTOBITO,
                IDFALTAEPI,
                IDAFASTAMENTO,
                IDINTERNACAO,
                IDREGPOLICIAL,
                NRREGPOLICIAL,
                IDINCAPACITADO,
                DTHRINICATEND,
                QTHRATEINICATEND,
                DTHRFIMATEND,
                QTHRATENDIMENTO,
                DTCAT,
                NRCAT,
                DSLOCALCAT,
                DSOBSERVACAO,
                NRTIPOLOCALCAT,
                IDACIDENTEBIO,
                DSPROFILAXIA,
                NRCEPENDERECO,
                NMBAIRROENDERECO,
                CDLOGRADOURO,
                DSENDERECO,
                NRIMOVELENDERECO,
                DSCOMPLEENDERECO,
                DSREFERENCIAENDE,
                NRAGENTCAUSAD,
                NRCATORIGEM,
                IDTIPOCAT,
                IDATIVO,
                NRORGINCLUSAO,
                DTINCLUSAO,
                CDOPERINCLUSAO,
                NRORGULTATU,
                DTULTATU,
                CDOPERULTATU
                ) VALUES (
                :P_NRVITIMA,
                :P_NRORG,
                :P_NRNATUREZA, 
                :P_NRGRAVIDADE, 
                :P_NRINFLUENCIAGERENCIAL,
                :P_NROCORRENCIA, 
                :P_NRPARCNEGOCIO,
                :P_CDPAIS,
                :P_SGESTADO,
                :P_CDMUNICIPIO,
                :P_DSACIDENTE, 
                :P_DSNATUREZAACID,
                :P_DSGRAVIDACID, 
                :P_DSINFLUGERACID,
                :P_QTHRAPOSINICTRAB,
                TO_DATE(:P_DTULTDIATRABALHADO,'DD/MM/YYYY'),
                :P_QTDIASDEBITADOS, 
                :P_QTDIASPERDIDOS, 
                :P_QTDIASTRABRESTRITO, 
                :P_QTHRPERDIDAS,
                :P_IDACIDFATAL,
                TO_DATE(:P_DTOBITO,'DD/MM/YYYY'),
                :P_IDFALTAEPI, 
                :P_IDAFASTAMENTO,
                :P_IDINTERNACAO,
                :P_IDREGPOLICIAL,
                :P_NRREGPOLICIAL,
                :P_IDINCAPACITADO,
                TO_DATE(:P_DTHRINICATEND,'DD/MM/YYYY HH24:MI:SS'),
                :P_QTHRATEINICATEND,
                TO_DATE(:P_DTHRFIMATEND,'DD/MM/YYYY HH24:MI:SS'),
                :P_QTHRATENDIMENTO,
                TO_DATE(:P_DTCAT,'DD/MM/YYYY'),
                :P_NRCAT,
                :P_DSLOCALCAT,
                :P_DSOBSERVACAO,
                :P_NRTIPOLOCALCAT,
                :P_IDACIDENTEBIO,
                :P_DSPROFILAXIA,
                :P_NRCEPENDERECO,
                :P_NMBAIRROENDERECO,
                :P_CDLOGRADOURO,
                :P_DSENDERECO,
                :P_NRIMOVELENDERECO,
                :P_DSCOMPLEENDERECO,
                :P_DSREFERENCIAENDE,
                :P_NRAGENTCAUSAD,
                :P_NRCATORIGEM,
                :P_IDTIPOCAT,
                :P_IDATIVO,
                :P_NRORGINCLUSAO,
                TO_DATE(:P_DTINCLUSAO,'DD/MM/YYYY'),
                :P_CDOPERINCLUSAO,
                :P_NRORGULTATU,
                TO_DATE(:P_DTULTATU,'DD/MM/YYYY'),
                :P_CDOPERULTATU
                )
SQL;
        
        $params = [
                'P_NRVITIMA'              => $nrVitima,
                'P_NRORG'                 => $nrorg,
                'P_NRNATUREZA'            => $rowDadosVitima['NRNATUREZA'] ?? NULL, 
                'P_NRGRAVIDADE'           => $rowDadosCAT['NRGRAVIDADE'] ?? NULL, 
                'P_NRINFLUENCIAGERENCIAL' => $rowDadosCAT['NRINFLUENCIAGERENCIAL'] ?? NULL, 
                'P_NROCORRENCIA'          => $nrOcorrencia,
                'P_NRPARCNEGOCIO'         => $rowDadosVitima['NRPARCNEGOCIO'] ?? NULL,
                'P_CDPAIS'                => $rowDadosVitima['CDPAIS'] ?? NULL,
                'P_SGESTADO'              => $rowDadosVitima['SGESTADO'] ?? NULL,
                'P_CDMUNICIPIO'           => $rowDadosVitima['CDMUNICIPIO'] ?? NULL,
                'P_DSACIDENTE'            => $rowDadosVitima['DSACIDENTE'] ?? NULL,
                'P_DSNATUREZAACID'        => $rowDadosVitima['DSNATUREZAACID'] ?? NULL,
                'P_DSGRAVIDACID'          => $rowDadosVitima['DSGRAVIDACID'] ?? NULL,
                'P_DSINFLUGERACID'        => $rowDadosVitima['DSINFLUGERACID'] ?? NULL,
                'P_QTHRAPOSINICTRAB'      => $rowDadosVitima['QTHRAPOSINICTRAB'] ?? NULL,
                'P_DTULTDIATRABALHADO'    => $rowDadosVitima['DTULTDIATRABALHADO'] ?? NULL,
                'P_QTDIASDEBITADOS'       => $rowDadosVitima['QTDIASDEBITADOS'] ?? NULL,
                'P_QTDIASPERDIDOS'        => $rowDadosVitima['QTDIASPERDIDOS'] ?? NULL,
                'P_QTDIASTRABRESTRITO'    => $rowDadosVitima['QTDIASTRABRESTRITO'] ?? NULL,
                'P_QTHRPERDIDAS'          => $rowDadosVitima['QTHRPERDIDAS'] ?? NULL,
                'P_IDACIDFATAL'           => $rowDadosVitima['IDACIDFATAL'] ?? NULL,
                'P_DTOBITO'               => $rowDadosVitima['DTOBITO'] ?? NULL,
                'P_IDFALTAEPI'            => $rowDadosVitima['IDFALTAEPI'] ?? 'N',
                'P_IDAFASTAMENTO'         => $rowDadosVitima['IDAFASTAMENTO'] ?? 'N',
                'P_IDINTERNACAO'          => $rowDadosVitima['IDINTERNACAO'] ?? 'N',
                'P_IDREGPOLICIAL'         => $rowDadosVitima['IDREGPOLICIAL'] ?? 'N',
                'P_NRREGPOLICIAL'         => $rowDadosVitima['NRREGPOLICIAL'] ?? NULL,
                'P_IDINCAPACITADO'        => $rowDadosVitima['IDINCAPACITADO'] ?? 'N',
                'P_DTHRINICATEND'         => $rowDadosVitima['DTHRINICATENDFORMAT'] ?? NULL,
                'P_QTHRATEINICATEND'      => $rowDadosVitima['QTHRATEINICATEND'] ?? NULL,
                'P_DTHRFIMATEND'          => $rowDadosVitima['DTHRFIMATEND'] ?? NULL,
                'P_QTHRATENDIMENTO'       => $rowDadosVitima['QTHRATENDIMENTO'] ?? NULL,
                'P_DTCAT'                 => $rowDadosVitima['DTCAT'] ?? NULL,
                'P_NRCAT'                 => $rowDadosVitima['NRCAT'] ?? NULL,
                'P_DSLOCALCAT'            => $rowDadosVitima['DSLOCALCAT'] ?? NULL,
                'P_DSOBSERVACAO'          => $rowDadosVitima['DSOBSERVACAOVITIMA'] ?? NULL,
                'P_NRTIPOLOCALCAT'        => $rowDadosVitima['NRTIPOLOCALCAT'] ?? NULL,
                'P_IDACIDENTEBIO'         => $rowDadosVitima['IDACIDENTEBIO'] ?? NULL,
                'P_DSPROFILAXIA'          => $rowDadosVitima['DSPROFILAXIA'] ?? NULL,
                'P_NRCEPENDERECO'         => $rowDadosVitima['NRCEPENDERECO'] ?? NULL,
                'P_NMBAIRROENDERECO'      => $rowDadosVitima['NMBAIRROENDERECO'] ?? NULL,
                'P_CDLOGRADOURO'          => $rowDadosVitima['CDLOGRADOURO'] ?? NULL,
                'P_DSENDERECO'            => $rowDadosVitima['DSENDERECO'] ?? NULL,
                'P_NRIMOVELENDERECO'      => $rowDadosVitima['NRIMOVELENDERECO'] ?? NULL,
                'P_DSCOMPLEENDERECO'      => $rowDadosVitima['DSCOMPLEENDERECO'] ?? NULL,
                'P_DSREFERENCIAENDE'      => $rowDadosVitima['DSREFERENCIAENDE'] ?? NULL,
                'P_NRAGENTCAUSAD'         => $rowDadosVitima['NRAGENTCAUSAD'] ?? NULL,
                'P_NRCATORIGEM'           => $rowDadosVitima['NRCATORIGEM'] ?? NULL,
                'P_IDTIPOCAT'             => $rowDadosVitima['IDTIPOCAT'] ?? NULL,

                "P_IDATIVO"                => $rowDadosVitima['IDATIVO']         ??  'S' ,
                "P_NRORGINCLUSAO"          => $nrorg  ??  NULL ,
                "P_DTINCLUSAO"             => $rowDadosVitima['DTINCLUSAO']     ??  NULL ,
                "P_CDOPERINCLUSAO"         => $cdoperador ,
                "P_NRORGULTATU"            => $nrorg   ?? NULL ,
                "P_DTULTATU"               => $rowDadosVitima['DTULTATU']    ??       NULL ,
                "P_CDOPERULTATU"           => $cdoperador ,
        ];
        

        $query = $this->entityManager->getConnection()->prepare($sql);
        $result = $query->execute($params);

        if($result === true) {
            return $nrVitima;
        }
    }

    public function setParteAtingida($rowDadosParteAtingida, $nrorg, $nrOcorrencia, $nrVitima, $cdoperador)
    {
        $nrVitParteAting = NovoCodigo::geraCodigo($nrorg, 'SST_VITIMAPARTEATINGIDA', 1, 22, true);
        $sql = <<<SQL
            INSERT INTO SST_VITIMAPARTEATINGIDA (
                NRVITPARTEATING,
                NRVITIMA,
                NRORG,
                NRPARTEATINGIDA,
                NROCORRENCIA,
                DSDIAGNOSTICO,
                DSOBSERVACAO,
                LATERALIDADE,
                IDATIVO,
                NRORGINCLUSAO,
                DTINCLUSAO,
                CDOPERINCLUSAO,
                NRORGULTATU,
                DTULTATU,
                CDOPERULTATU
            ) VALUES (
                :P_NRVITPARTEATING,
                :P_NRVITIMA,
                :P_NRORG,
                :P_NRPARTEATINGIDA,
                :P_NROCORRENCIA,
                :P_DSDIAGNOSTICO,
                :P_DSOBSERVACAO,
                :P_LATERALIDADE,
                :P_IDATIVO,
                :P_NRORGINCLUSAO,
                TO_DATE(:P_DTINCLUSAO,'DD/MM/YYYY'),
                :P_CDOPERINCLUSAO,
                :P_NRORGULTATU,
                TO_DATE(:P_DTULTATU,'DD/MM/YYYY'),
                :P_CDOPERULTATU
            )
SQL;
        
        $params = [
            'P_NRVITPARTEATING' => $nrVitParteAting,
            'P_NRVITIMA'        => $nrVitima,
            'P_NRORG'           => $nrorg,
            'P_NRPARTEATINGIDA' => $rowDadosParteAtingida['NRPARTEATINGIDA'] ?? NULL,
            'P_NROCORRENCIA'    => $nrOcorrencia,
            'P_DSDIAGNOSTICO'   => $rowDadosParteAtingida['DSDIAGNOSTICO'] ?? NULL,
            'P_DSOBSERVACAO'    => $rowDadosParteAtingida['DSOBSERVACAOVPA'] ?? NULL,
            'P_LATERALIDADE'    => $rowDadosParteAtingida['LATERALIDADE'] ?? NULL,

            "P_IDATIVO"         => $rowDadosParteAtingida['IDATIVO']         ??  'S' ,
            "P_NRORGINCLUSAO"   => $rowDadosParteAtingida['NRORGINCLUSAO']  ??  NULL ,
            "P_DTINCLUSAO"      => $rowDadosParteAtingida['DTINCLUSAO']     ??  NULL ,
            "P_CDOPERINCLUSAO"  => $cdoperador,
            "P_NRORGULTATU"     => $rowDadosParteAtingida['NRORGULTATU']   ?? NULL ,
            "P_DTULTATU"        => $rowDadosParteAtingida['DTULTATU']    ??       NULL ,
            "P_CDOPERULTATU"    => $cdoperador ,
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $result = $query->execute($params);
        
        return $result;
    }


    public function setFichaMedica($rowDadosFichaMedica, $nrorg, $rowDadosVitima, $nrOcorrencia, $cdoperador)
    {   
        $nrFichaMedica = NovoCodigo::geraCodigo($nrorg, 'SST_FICHAMEDICA', 1, 22, true);
       
        $sql = <<<SQL
                INSERT INTO SST_FICHAMEDICA (
                NRORG,
                NRFICHAMEDICA,
                NRNATUREZAEXAME,
                NRCONTROLEAPTIDAOATEND,
                NRCONTROLEAPTIDAOINSS,
                NRQUEIXA,
                NRMOTIVOAUSENCIA,
                NRVINCULOM,
                NRPARCNEGOCIO,
                NRTABRESULTEXAME,
                NRESTRUTURAM,
                NROCORRENCIA,
                NRSITUFUNCM,
                NRSITUFUNCMPROX,
                DTHRPREVFICHAMED,
                DTHREFETFICHAMED,
                NRINSCRCONSELHOATEND,
                DSLOCALATENDIMENTO,
                IDNEXOCAUSAL,
                IDEMISSAOCAT,
                NRCAT,
                NRBENEFICIO,
                IDBENEFICIO,
                DTCONCLFICHAMED,
                DTHRINIAFASTAMENTO,
                DTHRFIMAFASTAMENTO,
                DTPREVRETORNO,
                QTPESO,
                VRALTURA,
                VRIMC,
                VRPULSO,
                VRPRESSAOARTSISTOLICA,
                VRPRESSAOARTDIASTOLICA,
                VRTEMPERATURA,
                VREXAME,
                IDATIVO,
                NRORGINCLUSAO,
                DTINCLUSAO,
                CDOPERINCLUSAO,
                NRORGULTATU,
                DTULTATU,
                CDOPERULTATU
                ) VALUES (
                :P_NRORG,
                :P_NRFICHAMEDICA,
                :P_NRNATUREZAEXAME,
                :P_NRCONTROLEAPTIDAOATEND,
                :P_NRCONTROLEAPTIDAOINSS,
                :P_NRQUEIXA,
                :P_NRMOTIVOAUSENCIA,
                :P_NRVINCULOM,
                :P_NRPARCNEGOCIO,
                :P_NRTABRESULTEXAME,
                :P_NRESTRUTURAM,
                :P_NROCORRENCIA,
                :P_NRSITUFUNCM,
                :P_NRSITUFUNCMPROX,
                :P_DTHRPREVFICHAMED,
                :P_DTHRREFETFICHAMED,
                :P_NRINSCRCONSELHOATEND,
                :P_DSLOCALATENDIMENTO,
                :P_IDNEXOCAUSAL,
                :P_IDEMISSAOCAT,
                :P_NRCAT,
                :P_NRBENEFICIO,
                :P_IDBENEFICIO,
                :P_DTCONCLFICHAMED,
                :P_DTHRINIAFASTAMENTO,
                :P_DTHRFIMAFASTAMENTO,
                :P_DTPREVRETORNO,
                :P_QTPESO,
                :P_VRALTURA,
                :P_VRIMC,
                :P_VRPULSO,
                :P_VRPRESSAOARTSISTOLICA,
                :P_VRPRESSAOARTDIASTOLICA,
                :P_VRTEMPERATURA,
                :P_VREXAME,
                :P_IDATIVO,
                :P_NRORGINCLUSAO,
                TO_DATE(:P_DTINCLUSAO,'DD/MM/YYYY'),
                :P_CDOPERINCLUSAO,
                :P_NRORGULTATU,
                TO_DATE(:P_DTULTATU,'DD/MM/YYYY'),
                :P_CDOPERULTATU
                )
SQL;
        
        $params = [
                'P_NRORG'                      => $nrorg,
                'P_NRFICHAMEDICA'              => $nrFichaMedica,
                'P_NRNATUREZAEXAME'            => $rowDadosFichaMedica['NRNATUREZAEXAME'] ?? NULL,
                'P_NRCONTROLEAPTIDAOATEND'     => $rowDadosFichaMedica['NRCONTROLEAPTIDAOATEND'] ?? NULL,
                'P_NRCONTROLEAPTIDAOINSS'      => $rowDadosFichaMedica['NRCONTROLEAPTIDAOINSS'] ?? NULL,
                'P_NRQUEIXA'                   => $rowDadosFichaMedica['NRQUEIXA'] ?? NULL,
                'P_NRMOTIVOAUSENCIA'           => $rowDadosFichaMedica['NRMOTIVOAUSENCIA'] ?? NULL,
                'P_NRVINCULOM'                 => $rowDadosVitima['NRVINCULOM'] ?? NULL,
                'P_NRPARCNEGOCIO'              => $rowDadosFichaMedica['NRPARCNEGOCIOMEDICO'] ?? NULL,
                'P_NRTABRESULTEXAME'           => $rowDadosFichaMedica['NRTABRESULTEXAME'] ?? NULL,
                'P_NRESTRUTURAM'               => $rowDadosFichaMedica['NRESTRUTURAM'] ?? NULL,
                'P_NROCORRENCIA'               => $nrOcorrencia, 
                'P_NRSITUFUNCM'                => $rowDadosFichaMedica['NRSITUFUNCM'] ?? NULL,
                'P_NRSITUFUNCMPROX'            => $rowDadosFichaMedica['NRSITUFUNCMPROX'] ?? 1,
                'P_DTHRPREVFICHAMED'           => $rowDadosFichaMedica['DTHRPREVFICHAMED'] ?? NULL,
                'P_DTHRREFETFICHAMED'          => $rowDadosFichaMedica['DTHREFETFICHAMED'] ?? NULL,
                'P_NRINSCRCONSELHOATEND'       => $rowDadosFichaMedica['NRINSCRCONSELHOATEND'] ?? NULL,
                'P_DSLOCALATENDIMENTO'         => $rowDadosFichaMedica['DSLOCALATENDIMENTO'] ?? NULL,
                'P_IDNEXOCAUSAL'               => $rowDadosFichaMedica['IDNEXOCAUSAL'] ?? 'N',
                'P_IDEMISSAOCAT'               => $rowDadosFichaMedica['IDEMISSAOCAT'] ?? 'N',
                'P_NRCAT'                      => $rowDadosFichaMedica['NRCAT'] ?? NULL,
                'P_NRBENEFICIO'                => $rowDadosFichaMedica['NRBENEFICIO'] ?? 1,
                'P_IDBENEFICIO'                => $rowDadosFichaMedica['IDBENEFICIO'] ?? 'N',
                'P_DTCONCLFICHAMED'            => $rowDadosFichaMedica['DTCONCLFICHAMED'] ?? NULL,
                'P_DTHRINIAFASTAMENTO'         => $rowDadosFichaMedica['DTHRINIAFASTAMENTO'] ?? NULL,
                'P_DTHRFIMAFASTAMENTO'         => $rowDadosFichaMedica['DTHRFIMAFASTAMENTO'] ?? NULL,
                'P_DTPREVRETORNO'              => $rowDadosFichaMedica['DTPREVRETORNO'] ?? NULL,
                'P_QTPESO'                     => $rowDadosFichaMedica['QTPESO'] ?? NULL,
                'P_VRALTURA'                   => $rowDadosFichaMedica['VRALTURA'] ?? NULL,
                'P_VRIMC'                      => $rowDadosFichaMedica['VRIMC'] ?? NULL,
                'P_VRPULSO'                    => $rowDadosFichaMedica['VRPULSO'] ?? NULL,
                'P_VRPRESSAOARTSISTOLICA'      => $rowDadosFichaMedica['VRPRESSAOARTSISTOLICA'] ?? NULL,
                'P_VRPRESSAOARTDIASTOLICA'     => $rowDadosFichaMedica['VRPRESSAOARTDIASTOLICA'] ?? NULL,
                'P_VRTEMPERATURA'              => $rowDadosFichaMedica['VRTEMPERATURA'] ?? NULL,
                'P_VREXAME'                    => $rowDadosFichaMedica['VREXAME'] ?? NULL,

                
                "P_IDATIVO"                   => $rowDadosFichaMedica['IDATIVO']         ??  'S' ,
                "P_NRORGINCLUSAO"             => $rowDadosFichaMedica['NRORGINCLUSAO']  ??  NULL ,
                "P_DTINCLUSAO"                => $rowDadosFichaMedica['DTINCLUSAO']     ??  NULL ,
                "P_CDOPERINCLUSAO"            => $cdoperador ,
                "P_NRORGULTATU"               => $rowDadosFichaMedica['NRORGULTATU']   ?? NULL ,
                "P_DTULTATU"                  => $rowDadosFichaMedica['DTULTATU']    ??       NULL ,
                "P_CDOPERULTATU"              => $cdoperador ,
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $result = $query->execute($params);
        
        if($result === true) {
            return $nrFichaMedica;
        }
    }



    public function setDoenca( $rowDadosDoenca, $nrorg , $nrFichaMedica, $cdoperador )
    {
        $nrDoencaFichaMedica = NovoCodigo::geraCodigo($nrorg, 'SST_DOENCAFICHAMEDICA', 1, 22, true);
        $sql = <<<SQL
            INSERT INTO SST_DOENCAFICHAMEDICA (
                NRFICHAMEDICA,
                NRDOENCAFICHAMEDICA,
                NRORG,
                NRCID,
                DSDOENCAFICHAMEDICA,
                IDOCUPACIONAL,
                IDATIVO,
                NRORGINCLUSAO,
                DTINCLUSAO,
                CDOPERINCLUSAO,
                NRORGULTATU,
                DTULTATU,
                CDOPERULTATU
            ) VALUES (
                :P_NRFICHAMEDICA,
                :P_NRDOENCAFICHAMEDICA,
                :P_NRORG,
                :P_NRCID,
                :P_DSDOENCAFICHAMEDICA,
                :P_IDOCUPACIONAL,
                :P_IDATIVO,
                :P_NRORGINCLUSAO,
                TO_DATE(:P_DTINCLUSAO,'DD/MM/YYYY'),
                :P_CDOPERINCLUSAO,
                :P_NRORGULTATU,
                TO_DATE(:P_DTULTATU,'DD/MM/YYYY'),
                :P_CDOPERULTATU
            )
SQL;
        
        $params = [
            'P_NRFICHAMEDICA'         => $nrFichaMedica,
            'P_NRDOENCAFICHAMEDICA'   => $nrDoencaFichaMedica,
            'P_NRORG'                 => $nrorg,
            'P_NRCID'                 => $rowDadosDoenca['NRCID'] ?? NULL,
            'P_DSDOENCAFICHAMEDICA'   => $rowDadosDoenca['DSDOENCAFICHAMEDICA'] ?? NULL,
            'P_IDOCUPACIONAL'         => $rowDadosDoenca['IDOCUPACIONAL'] ??'N',

            "P_IDATIVO"         => $rowDadosDoenca['IDATIVO']         ??  'S' ,
            "P_NRORGINCLUSAO"   => $rowDadosDoenca['NRORGINCLUSAO']  ??  NULL ,
            "P_DTINCLUSAO"      => $rowDadosDoenca['DTINCLUSAO']     ??  NULL ,
            "P_CDOPERINCLUSAO"  => $cdoperador,
            "P_NRORGULTATU"     => $rowDadosDoenca['NRORGULTATU']   ?? NULL ,
            "P_DTULTATU"        => $rowDadosDoenca['DTULTATU']    ??       NULL ,
            "P_CDOPERULTATU"    => $cdoperador,
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $result = $query->execute($params);

        return $result;
    }

    public function updateOcorrenciaCAT(array $rowDadosCAT, string $nrorg, $cdoperador)
    {   
        $sql = <<<SQL
            UPDATE SST_OCORRENCIA SET
                NRESTRUTURAM = :P_NRESTRUTURAM,
                NRTIPOOCORRE = :P_NRTIPOOCORRE,
                NRCLASSIFICACAO = :P_NRCLASSIFICACAO,
                NRGRAVIDADE = :P_NRGRAVIDADE,
                NRINFLUENCIAGERENCIAL = :P_NRINFLUENCIAGERENCIAL,
                NRCAUSA = :P_NRCAUSA,
                NRACAO = :P_NRACAO,
                DTHROCORRENCIA = TO_DATE(:P_DTHROCORRENCIA,'DD/MM/YYYY HH24:MI:SS'),
                DTHRRELATOOCORRE = TO_DATE(:P_DTHRRELATOOCORRE,'DD/MM/YYYY HH24:MI:SS'),
                DSOCORRENCIA = :P_DSOCORRENCIA,
                IDOCORRENCIA = :P_IDOCORRENCIA,
                QTVITIMASOCORRE = :P_QTVITIMASOCORRE,
                DSOBSERVACAO = :P_DSOBSERVACAO,
                DSGRAVIDOCORRE = :P_DSGRAVIDOCORRE,
                DSTIPOOCORRE = :P_DSTIPOOCORRE,
                DSCLASSIFOCORRE = :P_DSCLASSIFOCORRE,
                DSINFLUGEROCORRE = :P_DSINFLUGEROCORRE,
                IDATIVO = :P_IDATIVO,
                NRORGINCLUSAO = :P_NRORGINCLUSAO,
                DTINCLUSAO = TO_DATE(:P_DTINCLUSAO,'DD/MM/YYYY'),
                CDOPERINCLUSAO = :P_CDOPERINCLUSAO,
                NRORGULTATU = :P_NRORGULTATU,
                DTULTATU = TO_DATE(:P_DTULTATU,'DD/MM/YYYY'),
                CDOPERULTATU = :P_CDOPERULTATU
            WHERE NROCORRENCIA = :P_NROCORRENCIA AND NRORG = :P_NRORG
SQL;

        $params = [
            'P_NROCORRENCIA'           => $rowDadosCAT['NROCORRENCIA']      ?? NULL,
            'P_NRESTRUTURAM'           => $rowDadosCAT['NRESTRUTURAM']      ?? NULL,
            'P_NRORG'                  => $nrorg,
            'P_NRTIPOOCORRE'           => $rowDadosCAT['NRTIPOOCORRE'] ?? NULL,
            'P_NRCLASSIFICACAO'        => $rowDadosCAT['NRCLASSIFICACAO'] ?? NULL,
            'P_NRGRAVIDADE'            => $rowDadosCAT['NRGRAVIDADE'] ?? NULL,
            'P_NRINFLUENCIAGERENCIAL'  => $rowDadosCAT['NRINFLUENCIAGERENCIAL'] ?? NULL,
            'P_NRCAUSA'                => $rowDadosCAT['NRCAUSA'] ?? NULL,
            'P_NRACAO'                 => $rowDadosCAT['NRACAO'] ?? NULL,
            'P_DTHROCORRENCIA'         => $rowDadosCAT['DTHROCORRENCIAFORMAT'] ?? NULL,
            'P_DTHRRELATOOCORRE'       => $rowDadosCAT['DTHROCORRENCIAFORMAT']  ?? NULL,
            'P_DSOCORRENCIA'           => $rowDadosCAT['DSOCORRENCIA'] ?? NULL,
            'P_IDOCORRENCIA'           => $rowDadosCAT['IDOCORRENCIA'] ?? NULL,
            'P_QTVITIMASOCORRE'        => $rowDadosCAT['QTVITIMASOCORRE'] ?? 1,
            'P_DSOBSERVACAO'           => $rowDadosCAT['DSOBERSVACAOOCO'] ?? NULL,
            'P_DSGRAVIDOCORRE'         => $rowDadosCAT['DSGRAVIDOCORRE'] ?? NULL,
            'P_DSTIPOOCORRE'           => $rowDadosCAT['DSTIPOOCORRE'] ?? NULL,
            'P_DSCLASSIFOCORRE'        => $rowDadosCAT['DSCLASSIFOCORRE'] ?? NULL,
            'P_DSINFLUGEROCORRE'       => $rowDadosCAT['DSINFLUGEROCORRE'] ?? NULL,
            "P_IDATIVO"                => $rowDadosCAT['IDATIVO']         ??  'S' ,
            "P_NRORGINCLUSAO"          => $nrorg ?? NULL,
            "P_DTINCLUSAO"             => $rowDadosCAT['DTINCLUSAO']     ??  NULL ,
            "P_CDOPERINCLUSAO"         => $cdoperador ,
            "P_NRORGULTATU"            => $nrorg ?? NULL,
            "P_DTULTATU"               => $rowDadosCAT['DTULTATU']    ?? NULL,
            "P_CDOPERULTATU"           => $cdoperador ,
        ];
        
        $query = $this->entityManager->getConnection()->prepare($sql);
        $result = $query->execute($params);
        
        return $result;
    }

    public function updateVitima($rowDadosVitima, $nrorg, $rowDadosCAT, $nrOcorrencia, $cdoperador)
    {
        $sql = <<<SQL
                    UPDATE SST_VITIMA SET
            NRNATUREZA = :P_NRNATUREZA,
            NRGRAVIDADE = :P_NRGRAVIDADE,
            NRINFLUENCIAGERENCIAL = :P_NRINFLUENCIAGERENCIAL,
            NRPARCNEGOCIO = :P_NRPARCNEGOCIO,
            CDPAIS = :P_CDPAIS,
            SGESTADO = :P_SGESTADO,
            CDMUNICIPIO = :P_CDMUNICIPIO,
            DSACIDENTE = :P_DSACIDENTE,
            DSNATUREZAACID = :P_DSNATUREZAACID,
            DSGRAVIDACID = :P_DSGRAVIDACID,
            DSINFLUGERACID = :P_DSINFLUGERACID,
            QTHRAPOSINICTRAB = :P_QTHRAPOSINICTRAB,
            DTULTDIATRABALHADO = :P_DTULTDIATRABALHADO,
            QTDIASDEBITADOS = :P_QTDIASDEBITADOS,
            QTDIASPERDIDOS = :P_QTDIASPERDIDOS,
            QTDIASTRABRESTRITO = :P_QTDIASTRABRESTRITO,
            QTHRPERDIDAS = :P_QTHRPERDIDAS,
            IDACIDFATAL = :P_IDACIDFATAL,
            DTOBITO =:P_DTOBITO,
            IDFALTAEPI = :P_IDFALTAEPI,
            IDAFASTAMENTO = :P_IDAFASTAMENTO,
            IDINTERNACAO = :P_IDINTERNACAO,
            IDREGPOLICIAL = :P_IDREGPOLICIAL,
            NRREGPOLICIAL = :P_NRREGPOLICIAL,
            IDINCAPACITADO = :P_IDINCAPACITADO,
            DTHRINICATEND = :P_DTHRINICATEND,
            QTHRATEINICATEND = :P_QTHRATEINICATEND,
            DTHRFIMATEND = :P_DTHRFIMATEND,
            QTHRATENDIMENTO = :P_QTHRATENDIMENTO,
            DTCAT = :P_DTCAT,
            NRCAT = :P_NRCAT,
            DSLOCALCAT = :P_DSLOCALCAT,
            DSOBSERVACAO = :P_DSOBSERVACAO,
            NRTIPOLOCALCAT = :P_NRTIPOLOCALCAT,
            IDACIDENTEBIO = :P_IDACIDENTEBIO,
            DSPROFILAXIA = :P_DSPROFILAXIA,
            NRCEPENDERECO = :P_NRCEPENDERECO,
            NMBAIRROENDERECO = :P_NMBAIRROENDERECO,
            CDLOGRADOURO = :P_CDLOGRADOURO,
            DSENDERECO = :P_DSENDERECO,
            NRIMOVELENDERECO = :P_NRIMOVELENDERECO,
            DSCOMPLEENDERECO = :P_DSCOMPLEENDERECO,
            DSREFERENCIAENDE = :P_DSREFERENCIAENDE,
            NRAGENTCAUSAD = :P_NRAGENTCAUSAD,
            NRCATORIGEM = :P_NRCATORIGEM,
            IDTIPOCAT = :P_IDTIPOCAT,
            IDATIVO = :P_IDATIVO,
            NRORGINCLUSAO = :P_NRORGINCLUSAO,
            DTINCLUSAO = :P_DTINCLUSAO,
            CDOPERINCLUSAO = :P_CDOPERINCLUSAO,
            NRORGULTATU = :P_NRORGULTATU,
            DTULTATU = :P_DTULTATU,
            CDOPERULTATU = :P_CDOPERULTATU
        WHERE NROCORRENCIA = :P_NROCORRENCIA AND NRVITIMA = :P_NRVITIMA AND NRORG = :P_NRORG
SQL;

        $params = [
            'P_NRNATUREZA'            => $rowDadosVitima['NRNATUREZA'] ?? NULL,
            'P_NRGRAVIDADE'           => $rowDadosCAT['NRGRAVIDADE'] ?? NULL,
            'P_NRINFLUENCIAGERENCIAL' => $rowDadosCAT['NRINFLUENCIAGERENCIAL'] ?? NULL,
            'P_NROCORRENCIA'          => $nrOcorrencia,
            'P_NRPARCNEGOCIO'         => $rowDadosVitima['NRPARCNEGOCIO'] ?? NULL,
            'P_CDPAIS'                => $rowDadosVitima['CDPAIS'] ?? NULL,
            'P_SGESTADO'              => $rowDadosVitima['SGESTADO'] ?? NULL,
            'P_CDMUNICIPIO'           => $rowDadosVitima['CDMUNICIPIO'] ?? NULL,
            'P_DSACIDENTE'            => $rowDadosVitima['DSACIDENTE'] ?? NULL,
            'P_DSNATUREZAACID'        => $rowDadosVitima['DSNATUREZAACID'] ?? NULL,
            'P_DSGRAVIDACID'          => $rowDadosVitima['DSGRAVIDACID'] ?? NULL,
            'P_DSINFLUGERACID'        => $rowDadosVitima['DSINFLUGERACID'] ?? NULL,
            'P_QTHRAPOSINICTRAB'      => $rowDadosVitima['QTHRAPOSINICTRAB'] ?? NULL,
            'P_DTULTDIATRABALHADO'    => $rowDadosVitima['DTULTDIATRABALHADO'] ?? NULL,
            'P_QTDIASDEBITADOS'       => $rowDadosVitima['QTDIASDEBITADOS'] ?? NULL,
            'P_QTDIASPERDIDOS'        => $rowDadosVitima['QTDIASPERDIDOS'] ?? NULL,
            'P_QTDIASTRABRESTRITO'    => $rowDadosVitima['QTDIASTRABRESTRITO'] ?? NULL,
            'P_QTHRPERDIDAS'          => $rowDadosVitima['QTHRPERDIDAS'] ?? NULL,
            'P_IDACIDFATAL'           => $rowDadosVitima['IDACIDFATAL'] ?? NULL,
            'P_DTOBITO'               => $rowDadosVitima['DTOBITO'] ?? NULL,
            'P_IDFALTAEPI'            => $rowDadosVitima['IDFALTAEPI'] ?? 'N',
            'P_IDAFASTAMENTO'         => $rowDadosVitima['IDAFASTAMENTO'] ?? 'N',
            'P_IDINTERNACAO'          => $rowDadosVitima['IDINTERNACAO'] ?? 'N',
            'P_IDREGPOLICIAL'         => $rowDadosVitima['IDREGPOLICIAL'] ?? 'N',
            'P_NRREGPOLICIAL'         => $rowDadosVitima['NRREGPOLICIAL'] ?? NULL,
            'P_IDINCAPACITADO'        => $rowDadosVitima['IDINCAPACITADO'] ?? 'N',
            'P_DTHRINICATEND'         => $rowDadosVitima['DTHRINICATENDFORMAT'] ?? NULL,
            'P_QTHRATEINICATEND'      => $rowDadosVitima['QTHRATEINICATEND'] ?? NULL,
            'P_DTHRFIMATEND'          => $rowDadosVitima['DTHRFIMATENDFORMAT'] ?? NULL,
            'P_QTHRATENDIMENTO'       => $rowDadosVitima['QTHRATENDIMENTO'] ?? NULL,
            'P_DTCAT'                 => $rowDadosVitima['DTCAT'] ?? NULL,
            'P_NRCAT'                 => $rowDadosVitima['NRCAT'] ?? NULL,
            'P_DSLOCALCAT'            => $rowDadosVitima['DSLOCALCAT'] ?? NULL,
            'P_DSOBSERVACAO'          => $rowDadosVitima['DSOBSERVACAOVITIMA'] ?? NULL,
            'P_NRTIPOLOCALCAT'        => $rowDadosVitima['NRTIPOLOCALCAT'] ?? NULL,
            'P_IDACIDENTEBIO'         => $rowDadosVitima['IDACIDENTEBIO'] ?? NULL,
            'P_DSPROFILAXIA'          => $rowDadosVitima['DSPROFILAXIA'] ?? NULL,
            'P_NRCEPENDERECO'         => $rowDadosVitima['NRCEPENDERECO'] ?? NULL,
            'P_NMBAIRROENDERECO'      => $rowDadosVitima['NMBAIRROENDERECO'] ?? NULL,
            'P_CDLOGRADOURO'          => $rowDadosVitima['CDLOGRADOURO'] ?? NULL,
            'P_DSENDERECO'            => $rowDadosVitima['DSENDERECO'] ?? NULL,
            'P_NRIMOVELENDERECO'      => $rowDadosVitima['NRIMOVELENDERECO'] ?? NULL,
            'P_DSCOMPLEENDERECO'      => $rowDadosVitima['DSCOMPLEENDERECO'] ?? NULL,
            'P_DSREFERENCIAENDE'      => $rowDadosVitima['DSREFERENCIAENDE'] ?? NULL,
            'P_NRAGENTCAUSAD'         => $rowDadosVitima['NRAGENTCAUSAD'] ?? NULL,
            'P_NRCATORIGEM'           => $rowDadosVitima['NRCATORIGEM'] ?? NULL,
            'P_IDTIPOCAT'             => $rowDadosVitima['IDTIPOCAT'] ?? NULL,
            'P_IDATIVO'               => $rowDadosVitima['IDATIVO'] ?? 'S',
            'P_NRORGINCLUSAO'         => $nrorg ?? NULL,
            'P_DTINCLUSAO'            => $rowDadosVitima['DTINCLUSAO'] ?? NULL,
            'P_CDOPERINCLUSAO'        => null,
            'P_NRORGULTATU'           => $nrorg ?? NULL,
            'P_DTULTATU'              => $rowDadosVitima['DTULTATU'] ?? NULL,
            'P_CDOPERULTATU'          => null,
            'P_NRVITIMA'              => $rowDadosVitima['NRVITIMA'] ?? NULL,
            'P_NRORG'                 => $nrorg,
        ];

        $query = $this->entityManager->getConnection()->prepare($sql);
        $result = $query->execute($params);

        return $result;
    }

    public function updateParteAtingida($rowDadosParteAtingida, $nrorg, $nrOcorrencia, $nrVitima, $cdoperador)
    {   
        $dataAtualizacao = date('d/m/Y H:i:s');
        $sql = <<<SQL
        UPDATE SST_VITIMAPARTEATINGIDA SET
        NRPARTEATINGIDA = :P_NRPARTEATINGIDA,
        DSDIAGNOSTICO = :P_DSDIAGNOSTICO,
        DSOBSERVACAO = :P_DSOBSERVACAO,
        LATERALIDADE = :P_LATERALIDADE,
        IDATIVO = :P_IDATIVO,
        NRORGINCLUSAO = :P_NRORGINCLUSAO,
        DTINCLUSAO = :P_DTINCLUSAO,
        CDOPERINCLUSAO = :P_CDOPERINCLUSAO,
        NRORGULTATU = :P_NRORGULTATU,
        DTULTATU = :P_DTULTATU,
        CDOPERULTATU = :P_CDOPERULTATU
    WHERE NROCORRENCIA = :P_NROCORRENCIA
    AND NRVITIMA = :P_NRVITIMA
    AND NRVITPARTEATING = :P_NRVITPARTEATING
    AND NRORG = :P_NRORG
SQL;

    $params = [
        'P_NRVITPARTEATING' => $rowDadosParteAtingida['NRVITPARTEATING'] ?? NULL,
        'P_NRVITIMA'        => $nrVitima ?? NULL,
        'P_NRORG'           => $nrorg,
        'P_NRPARTEATINGIDA' => $rowDadosParteAtingida['NRPARTEATINGIDA'] ?? NULL,
        'P_NROCORRENCIA'    => $nrOcorrencia ?? NULL,
        'P_DSDIAGNOSTICO'   => $rowDadosParteAtingida['DSDIAGNOSTICO'] ?? NULL,
        'P_DSOBSERVACAO'    => $rowDadosParteAtingida['DSOBSERVACAOVPA'] ?? NULL,
        'P_LATERALIDADE'    => $rowDadosParteAtingida['LATERALIDADE'] ?? NULL,
        'P_IDATIVO'         => $rowDadosParteAtingida['IDATIVO'] ?? 'S',
        'P_NRORGINCLUSAO'   => $nrorg,
        'P_DTINCLUSAO'      => $rowDadosParteAtingida['DTINCLUSAO'] ?? NULL,
        'P_CDOPERINCLUSAO'  => $cdoperador,
        'P_NRORGULTATU'     => $nrorg,
        'P_DTULTATU'        => $dataAtualizacao,
        'P_CDOPERULTATU'    => $cdoperador
    ];

        $query = $this->entityManager->getConnection()->prepare($sql);
        $result = $query->execute($params);

        return $result;
    }

    public function updateFichaMedica($rowDadosFichaMedica, $nrorg, $rowDadosVitima, $nrOcorrencia, $cdoperador)
    {
        $sql = <<<SQL
            UPDATE SST_FICHAMEDICA SET
                NRNATUREZAEXAME = :P_NRNATUREZAEXAME,
                NRCONTROLEAPTIDAOATEND = :P_NRCONTROLEAPTIDAOATEND,
                NRCONTROLEAPTIDAOINSS = :P_NRCONTROLEAPTIDAOINSS,
                NRQUEIXA = :P_NRQUEIXA,
                NRMOTIVOAUSENCIA = :P_NRMOTIVOAUSENCIA,
                NRVINCULOM = :P_NRVINCULOM,
                NRPARCNEGOCIO = :P_NRPARCNEGOCIO,
                NRTABRESULTEXAME = :P_NRTABRESULTEXAME,
                NRESTRUTURAM = :P_NRESTRUTURAM,
                NRSITUFUNCM = :P_NRSITUFUNCM,
                NRSITUFUNCMPROX = :P_NRSITUFUNCMPROX,
                DTHRPREVFICHAMED = :P_DTHRPREVFICHAMED,
                DTHREFETFICHAMED = :P_DTHRREFETFICHAMED,
                NRINSCRCONSELHOATEND = :P_NRINSCRCONSELHOATEND,
                DSLOCALATENDIMENTO = :P_DSLOCALATENDIMENTO,
                IDNEXOCAUSAL = :P_IDNEXOCAUSAL,
                IDEMISSAOCAT = :P_IDEMISSAOCAT,
                NRCAT = :P_NRCAT,
                NRBENEFICIO = :P_NRBENEFICIO,
                IDBENEFICIO = :P_IDBENEFICIO,
                DTCONCLFICHAMED = :P_DTCONCLFICHAMED,
                DTHRINIAFASTAMENTO = :P_DTHRINIAFASTAMENTO,
                DTHRFIMAFASTAMENTO = :P_DTHRFIMAFASTAMENTO,
                DTPREVRETORNO = :P_DTPREVRETORNO,
                QTPESO = :P_QTPESO,
                VRALTURA = :P_VRALTURA,
                VRIMC = :P_VRIMC,
                VRPULSO = :P_VRPULSO,
                VRPRESSAOARTSISTOLICA = :P_VRPRESSAOARTSISTOLICA,
                VRPRESSAOARTDIASTOLICA = :P_VRPRESSAOARTDIASTOLICA,
                VRTEMPERATURA = :P_VRTEMPERATURA,
                VREXAME = :P_VREXAME,
                IDATIVO = :P_IDATIVO,
                NRORGINCLUSAO = :P_NRORGINCLUSAO,
                DTINCLUSAO = :P_DTINCLUSAO,
                CDOPERINCLUSAO = :P_CDOPERINCLUSAO,
                NRORGULTATU = :P_NRORGULTATU,
                DTULTATU = :P_DTULTATU,
                CDOPERULTATU = :P_CDOPERULTATU
            WHERE NRFICHAMEDICA = :P_NRFICHAMEDICA
            AND NRORG = :P_NRORG
            AND NROCORRENCIA = :P_NROCORRENCIA
SQL;

        $params = [
            'P_NRFICHAMEDICA'            => $rowDadosFichaMedica['NRFICHAMEDICA'] ?? NULL,
            'P_NRORG'                    => $nrorg,
            'P_NRNATUREZAEXAME'          => $rowDadosFichaMedica['NRNATUREZAEXAME'] ?? NULL,
            'P_NRCONTROLEAPTIDAOATEND'   => $rowDadosFichaMedica['NRCONTROLEAPTIDAOATEND'] ?? NULL,
            'P_NRCONTROLEAPTIDAOINSS'    => $rowDadosFichaMedica['NRCONTROLEAPTIDAOINSS'] ?? NULL,
            'P_NRQUEIXA'                 => $rowDadosFichaMedica['NRQUEIXA'] ?? NULL,
            'P_NRMOTIVOAUSENCIA'         => $rowDadosFichaMedica['NRMOTIVOAUSENCIA'] ?? NULL,
            'P_NRVINCULOM'               => $rowDadosVitima['NRVINCULOM'] ?? NULL,
            'P_NRPARCNEGOCIO'            => $rowDadosFichaMedica['NRPARCNEGOCIOMEDICO'] ?? NULL,
            'P_NRTABRESULTEXAME'         => $rowDadosFichaMedica['NRTABRESULTEXAME'] ?? NULL,
            'P_NRESTRUTURAM'             => $rowDadosFichaMedica['NRESTRUTURAM'] ?? NULL,
            'P_NRSITUFUNCM'              => $rowDadosFichaMedica['NRSITUFUNCM'] ?? NULL,
            'P_NRSITUFUNCMPROX'          => $rowDadosFichaMedica['NRSITUFUNCMPROX'] ?? 1,
            'P_DTHRPREVFICHAMED'         => $rowDadosFichaMedica['DTHRPREVFICHAMED'] ?? NULL,
            'P_DTHRREFETFICHAMED'        => $rowDadosFichaMedica['DTHREFETFICHAMED'] ?? NULL,
            'P_NRINSCRCONSELHOATEND'     => $rowDadosFichaMedica['NRINSCRCONSELHOATEND'] ?? NULL,
            'P_DSLOCALATENDIMENTO'       => $rowDadosFichaMedica['DSLOCALATENDIMENTO'] ?? NULL,
            'P_IDNEXOCAUSAL'             => $rowDadosFichaMedica['IDNEXOCAUSAL'] ?? 'N',
            'P_IDEMISSAOCAT'             => $rowDadosFichaMedica['IDEMISSAOCAT'] ?? 'N',
            'P_NRCAT'                    => $rowDadosFichaMedica['NRCAT'] ?? NULL,
            'P_NRBENEFICIO'              => $rowDadosFichaMedica['NRBENEFICIO'] ?? 1,
            'P_IDBENEFICIO'              => $rowDadosFichaMedica['IDBENEFICIO'] ?? 'N',
            'P_DTCONCLFICHAMED'          => $rowDadosFichaMedica['DTCONCLFICHAMED'] ?? NULL,
            'P_DTHRINIAFASTAMENTO'       => $rowDadosFichaMedica['DTHRINIAFASTAMENTO'] ?? NULL,
            'P_DTHRFIMAFASTAMENTO'       => $rowDadosFichaMedica['DTHRFIMAFASTAMENTO'] ?? NULL,
            'P_DTPREVRETORNO'            => $rowDadosFichaMedica['DTPREVRETORNO'] ?? NULL,
            'P_QTPESO'                   => $rowDadosFichaMedica['QTPESO'] ?? NULL,
            'P_VRALTURA'                 => $rowDadosFichaMedica['VRALTURA'] ?? NULL,
            'P_VRIMC'                    => $rowDadosFichaMedica['VRIMC'] ?? NULL,
            'P_VRPULSO'                  => $rowDadosFichaMedica['VRPULSO'] ?? NULL,
            'P_VRPRESSAOARTSISTOLICA'    => $rowDadosFichaMedica['VRPRESSAOARTSISTOLICA'] ?? NULL,
            'P_VRPRESSAOARTDIASTOLICA'   => $rowDadosFichaMedica['VRPRESSAOARTDIASTOLICA'] ?? NULL,
            'P_VRTEMPERATURA'            => $rowDadosFichaMedica['VRTEMPERATURA'] ?? NULL,
            'P_VREXAME'                  => $rowDadosFichaMedica['VREXAME'] ?? NULL,
            'P_IDATIVO'                  => $rowDadosFichaMedica['IDATIVO'] ?? 'S',
            'P_NRORGINCLUSAO'            => $nrorg,
            'P_DTINCLUSAO'               => $rowDadosFichaMedica['DTINCLUSAO'] ?? NULL,
            'P_CDOPERINCLUSAO'           => $cdoperador,
            'P_NRORGULTATU'              => $nrorg,
            'P_DTULTATU'                 => $rowDadosFichaMedica['DTULTATU'] ?? NULL,
            'P_CDOPERULTATU'             => $cdoperador,
            'P_NROCORRENCIA'             => $nrOcorrencia,
        ];

        $query = $this->entityManager->getConnection()->prepare($sql);
        $result = $query->execute($params);

        return $result;
    }

    public function updateDoenca($rowDadosDoenca, $nrorg, $nrFichaMedica, $cdoperador)
    {
        $sql = <<<SQL
            UPDATE SST_DOENCAFICHAMEDICA SET
                NRCID = :P_NRCID,
                DSDOENCAFICHAMEDICA = :P_DSDOENCAFICHAMEDICA,
                IDOCUPACIONAL = :P_IDOCUPACIONAL,
                IDATIVO = :P_IDATIVO,
                NRORGINCLUSAO = :P_NRORGINCLUSAO,
                DTINCLUSAO = :P_DTINCLUSAO,
                CDOPERINCLUSAO = :P_CDOPERINCLUSAO,
                NRORGULTATU = :P_NRORGULTATU,
                DTULTATU = :P_DTULTATU,
                CDOPERULTATU = :P_CDOPERULTATU
            WHERE NRFICHAMEDICA = :P_NRFICHAMEDICA
            AND NRDOENCAFICHAMEDICA = :P_NRDOENCAFICHAMEDICA
            AND NRORG = :P_NRORG
SQL;

        $params = [
            'P_NRFICHAMEDICA'         => $nrFichaMedica,
            'P_NRDOENCAFICHAMEDICA'   => $rowDadosDoenca['NRDOENCAFICHAMEDICA'],
            'P_NRORG'                 => $nrorg,
            'P_NRCID'                 => $rowDadosDoenca['NRCID'] ?? NULL,
            'P_DSDOENCAFICHAMEDICA'   => $rowDadosDoenca['DSDOENCAFICHAMEDICA'] ?? NULL,
            'P_IDOCUPACIONAL'         => $rowDadosDoenca['IDOCUPACIONAL'] ?? 'N',
            'P_IDATIVO'               => $rowDadosDoenca['IDATIVO'] ?? 'S',
            'P_NRORGINCLUSAO'         => $nrorg,
            'P_DTINCLUSAO'            => $rowDadosDoenca['DTINCLUSAO'] ?? NULL,
            'P_CDOPERINCLUSAO'        => $cdoperador,
            'P_NRORGULTATU'           => $nrorg,
            'P_DTULTATU'              => $rowDadosDoenca['DTULTATU'] ?? NULL,
            'P_CDOPERULTATU'          => $cdoperador,
        ];

        $query = $this->entityManager->getConnection()->prepare($sql);
        $result = $query->execute($params);

        return $result;
    }



    
    public function deleteOcorrenciaCAT($nrOcorrencia, $nrorg) {
        try {

            $sql = <<<SQL
                    DELETE FROM SST_OCORRENCIA
                    WHERE NRORG = :P_NRORG AND NROCORRENCIA = :P_NROCORRENCIA
SQL;

            $params = [
                "P_NROCORRENCIA"   => $nrOcorrencia,
                "P_NRORG"            => $nrorg,
            ];

            $query = $this->entityManager->getConnection()->prepare($sql);
            $result = $query->execute($params);

            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function deleteVitima($nrVitima, $nrorg, $nrOcorrencia) {
        try {

            $sql = <<<SQL
                    DELETE FROM SST_VITIMA
                    WHERE NRORG = :P_NRORG AND NROCORRENCIA = :P_NROCORRENCIA AND NRVITIMA = :P_NRVITIMA
SQL;

            $params = [
                "P_NROCORRENCIA"   => $nrOcorrencia,
                "P_NRORG"          => $nrorg,
                "P_NRVITIMA"       => $nrVitima,
            ];

            $query = $this->entityManager->getConnection()->prepare($sql);
            $result = $query->execute($params);

            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }


    public function deleteParteAtingida($nrVitParteAting, $nrorg, $nrOcorrencia, $nrVitima) {
        try {

            $sql = <<<SQL
                    DELETE FROM SST_VITIMAPARTEATINGIDA
                    WHERE NRORG = :P_NRORG AND NRVITPARTEATING = :P_NRVITPARTEATING  AND NRVITIMA = :P_NRVITIMA AND NROCORRENCIA = :P_NROCORRENCIA
SQL;

            $params = [
                "P_NROCORRENCIA"       => $nrOcorrencia,
                "P_NRORG"              => $nrorg,
                "P_NRVITIMA"           => $nrVitima,
                "P_NRVITPARTEATING"    => $nrVitParteAting,
            ];

            $query = $this->entityManager->getConnection()->prepare($sql);
            $result = $query->execute($params);

            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function deleteFichaMedica($nrFichaMedica, $nrorg, $nrOcorrencia) {
        try {

            $sql = <<<SQL
                    DELETE FROM SST_FICHAMEDICA
                    WHERE NRORG = :P_NRORG AND NRFICHAMEDICA = :P_NRFICHAMEDICA  AND NROCORRENCIA = :P_NROCORRENCIA
SQL;

            $params = [
                "P_NROCORRENCIA"       => $nrOcorrencia,
                "P_NRORG"              => $nrorg,
                "P_NRFICHAMEDICA"      => $nrFichaMedica,
            ];

            $query = $this->entityManager->getConnection()->prepare($sql);
            $result = $query->execute($params);

            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }

        
    public function deleteDoenca($nrDoencaFichaMedica, $nrorg , $nrFichaMedica) {
        try {
            $sql = <<<SQL
                    DELETE FROM SST_DOENCAFICHAMEDICA
                    WHERE NRORG = :P_NRORG AND NRDOENCAFICHAMEDICA = :P_NRDOENCAFICHAMEDICA AND NRFICHAMEDICA = :P_NRFICHAMEDICA
SQL;

            $params = [
                "P_NRDOENCAFICHAMEDICA"   => $nrDoencaFichaMedica,
                "P_NRORG"                 => $nrorg,
                "P_NRFICHAMEDICA"         => $nrFichaMedica,
            ];

            $query = $this->entityManager->getConnection()->prepare($sql);
            $result = $query->execute($params);

            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function getFonteGeradora (array $params): array {
        $sql = <<<SQL
        SELECT OC.*,
         SG.DSSITUGERADORA
FROM SST_TIPOOCORRE OC
LEFT JOIN SST_SITUGERADORA SG
    ON SG.NRSITUGERADORA = OC.NRSITUGERADORA
        AND (SG.NRORG = OC.NRORG
        OR SG.NRORG = :P_NRORG_PADRAO)
WHERE OC.NRORG = :P_NRORG
        OR OC.NRORG = :P_NRORG_PADRAO
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $fonteGeradora = $std->fetchAll();

        return $fonteGeradora;
    }

    public function getClassificacaoOcorrencia (array $params): array {
        $sql = <<<SQL
        SELECT CL.*,
         TA.DSTIPOACIDENTE,
         TA.CDESOCIAL
FROM SST_CLASSIFICACAO CL
LEFT JOIN SST_TIPOACIDENTE TA
    ON TA.NRTIPOACIDENTE = CL.NRTIPOACIDENTE
        AND (TA.NRORG = CL.NRORG
        OR TA.NRORG = :P_NRORG_PADRAO)
WHERE CL.NRORG = :P_NRORG
        OR CL.NRORG = :P_NRORG_PADRAO
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();

        
    }

    public function getGravidadeOcorrencia (array $params): array {
        $sql = <<<SQL
        SELECT *
FROM SST_GRAVIDADE
WHERE (NRORG = :P_NRORG
        OR NRORG = :P_NRORG_PADRAO)
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }
    
    public function getInfluenciaGeral (array $params): array {
        $sql = <<<SQL
  SELECT *
FROM SST_INFLUENCIAGERENCIAL
WHERE (NRORG = :P_NRORG
        OR NRORG = :P_NRORG_PADRAO)
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }

        
    public function getAgenteCausadorAcidTrab (array $params): array {
        $sql = <<<SQL
 SELECT *
FROM SST_CAUSA
WHERE (NRORG = :P_NRORG
        OR NRORG = :P_NRORG_PADRAO)
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }

    public function getNaturezaExame (array $params): array {
        $sql = <<<SQL
 SELECT *
FROM SST_NATUREZAEXAME
WHERE (NRORG = :P_NRORG
        OR NRORG = :P_NRORG_PADRAO)
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }

    public function getTipoLocalCat (array $params): array {
        $sql = <<<SQL
 SELECT NRTIPOLOCALCAT,
         REPLACE(REPLACE(REPLACE(REPLACE(DSTIPOLOCALCAT ,
         'Ãº', 'ú') , 'Ã', 'Á') , 'Ã§', 'ç') , 'Ã£', 'ã') AS DSTIPOLOCALCAT, CDESOCIAL, NRORG, IDATIVO, DTINCLUSAO, DTULTATU, NRORGINCLUSAO, CDOPERINCLUSAO, NRORGULTATU, CDOPERULTATU
FROM SST_TIPOLOCALCAT
WHERE (NRORG = :P_NRORG
        OR NRORG = :P_NRORG_PADRAO)
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }

    public function getNaturezaOcorrencia (array $params): array {
        $sql = <<<SQL
        SELECT SST_NATUREZA.*,
         ESO_NATUREZALESAO.DSNATUREZALESAO
FROM SST_NATUREZA
LEFT JOIN ESO_NATUREZALESAO
    ON ( SST_NATUREZA.NRNATUREZALESAO = ESO_NATUREZALESAO.NRNATUREZALESAO
        AND (ESO_NATUREZALESAO.NRORG = :P_NRORG
        OR ESO_NATUREZALESAO.NRORG = :P_NRORG_PADRAO) )
WHERE (SST_NATUREZA.NRORG = :P_NRORG
        OR SST_NATUREZA.NRORG = :P_NRORG_PADRAO)
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }

    public function getAgenteCausador (array $params): array {
        $sql = <<<SQL
        SELECT *
FROM SST_AGENTCAUSAD
WHERE (NRORG = :P_NRORG
        OR NRORG = :P_NRORG_PADRAO)
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }

    public function getParteAtingida (array $params): array {
        $sql = <<<SQL
        SELECT PA.*,
         PC.DSPARTATINGESOC
FROM SST_PARTEATINGIDA PA
JOIN SST_PARTATINGESOC PC
    ON PC.NRPARTATINGESOC = PA.NRPARTATINGESOC
        AND (PC.NRORG = PA.NRORG
        OR PC.NRORG = :P_NRORG_PADRAO)
WHERE PA.NRORG = :P_NRORG
        OR PA.NRORG = :P_NRORG_PADRAO
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }

    public function getMotivoAusencia (array $params): array {
        $sql = <<<SQL
       SELECT *
FROM SST_MOTIVOAUSENCIA
WHERE (NRORG = :P_NRORG
        OR NRORG = :P_NRORG_PADRAO)
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }


    public function getQueixa (array $params): array {
        $sql = <<<SQL
         SELECT *
FROM SST_QUEIXA
WHERE (NRORG = :P_NRORG
        OR NRORG = :P_NRORG_PADRAO)
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }

    public function getResultadoExame (array $params): array {
        $sql = <<<SQL
        SELECT *
FROM SST_TABRESULTEXAME
WHERE (NRORG = :P_NRORG
        OR NRORG = :P_NRORG_PADRAO)
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }

    public function getSituacao (array $params): array {
        $sql = <<<SQL
        SELECT SM.DTINIVIGENCIA,
         SM.DTFIMVIGENCIA,
         PROX_SITU.NMSITUFUNCH NMPROXSITUFUNC,
         SH.*
FROM GPE_SITUFUNCM SM
JOIN GPE_SITUFUNCH SH
    ON ( SH.NRORG = :P_NRORG
        OR SH.NRORG = :P_NRORG_PADRAO )
        AND SH.NRSITUFUNCM = SM.NRSITUFUNCM
        AND SH.DTEFETIVA = 
    (SELECT MAX(DTEFETIVA)
    FROM GPE_SITUFUNCH
    WHERE NRORG = SH.NRORG
            AND NRSITUFUNCM = SH.NRSITUFUNCM
            AND DTEFETIVA <= :P_DTEFETIVA )
LEFT JOIN GPE_SITUFUNCH PROX_SITU
    ON PROX_SITU.NRSITUFUNCM = SH.NRPROXSITUFUNC
        AND PROX_SITU.DTEFETIVA = 
    (SELECT MAX(DTEFETIVA)
    FROM GPE_SITUFUNCH
    WHERE GPE_SITUFUNCH.NRSITUFUNCM = SH.NRPROXSITUFUNC
            AND GPE_SITUFUNCH.DTEFETIVA <= :P_DTEFETIVA )
WHERE ( SM.NRORG = :P_NRORG
        OR SM.NRORG = :P_NRORG_PADRAO )
        AND ( SM.DTFIMVIGENCIA IS NULL
        OR SM.DTFIMVIGENCIA >= :P_DTEFETIVA
        OR NVL(:P_ATIVO, 'N') != 'S' )
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }

    public function getProximaSituacao (array $params): array {
        $sql = <<<SQL
              SELECT SM.DTINIVIGENCIA,
         SM.DTFIMVIGENCIA,
         PROX_SITU.NMSITUFUNCH NMPROXSITUFUNC,
         SH.*
FROM GPE_SITUFUNCM SM
JOIN GPE_SITUFUNCH SH
    ON ( SH.NRORG = :P_NRORG
        OR SH.NRORG = :P_NRORG_PADRAO )
        AND SH.NRSITUFUNCM = SM.NRSITUFUNCM
        AND SH.DTEFETIVA = 
    (SELECT MAX(DTEFETIVA)
    FROM GPE_SITUFUNCH
    WHERE NRORG = SH.NRORG
            AND NRSITUFUNCM = SH.NRSITUFUNCM
            AND DTEFETIVA <= :P_DTEFETIVA )
LEFT JOIN GPE_SITUFUNCH PROX_SITU
    ON PROX_SITU.NRSITUFUNCM = SH.NRPROXSITUFUNC
        AND PROX_SITU.DTEFETIVA = 
    (SELECT MAX(DTEFETIVA)
    FROM GPE_SITUFUNCH
    WHERE GPE_SITUFUNCH.NRSITUFUNCM = SH.NRPROXSITUFUNC
            AND GPE_SITUFUNCH.DTEFETIVA <= :P_DTEFETIVA )
WHERE ( SM.NRORG = :P_NRORG
        OR SM.NRORG = :P_NRORG_PADRAO )
        AND ( SM.DTFIMVIGENCIA IS NULL
        OR SM.DTFIMVIGENCIA >= :P_DTEFETIVA
        OR NVL(:P_ATIVO, 'N') != 'S' )
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }

    public function getCID (): array {
        $sql = <<<SQL
                SELECT * FROM SST_CID

SQL;

        $std = $this->connection->prepare($sql);
        $std->execute();

        return $std->fetchAll();
        
    }  

    public function getControleapt (array $params): array {
        $sql = <<<SQL
         SELECT *
FROM SST_CONTROLEAPTIDAO
WHERE (NRORG = :P_NRORG
        OR NRORG = :P_NRORG_PADRAO)
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        return $std->fetchAll();
        
    }  

    function formatDate($date, $format = 'd/m/Y') {
        if ($date === NULL || $date === '') {
            return NULL;
        }
        $datetime = DateTime::createFromFormat($format, $date);
        
        return $datetime->format('d/m/Y');
    }
    
    function formatDateTime($datetime, $format = 'd/m/Y H:i:s') {
        if ($datetime === NULL || $datetime === '') {
            return NULL;
        }
        $dateTimeObj = DateTime::createFromFormat($format, $datetime);
        return $dateTimeObj->format('d/m/Y H:i:s');
    }
}