<?php

namespace HCM\FPA\ObrigacaoLegal\CNAB\Bradesco;

use HCM\Util\FPA;
use HCM\Util\Repositories;
use HCM\Util\DateUtil;
use HCM\Util\Util;
use HCM\Util\MsgCalculo;
use HCM\FPA\Entity\FpaFormcnabEntity;
use HCM\FPA\Entity\FpaCnabmagnetEntity;
use HCM\FPA\ObrigacaoLegal\CNAB\Bradesco\Cnab240;

class Cnab240237 extends Cnab240{

    private $bufferSaida = '';      //Local da string de saída (arquivo)
    private $contador = 1;          //Contador de seqüência
    private $arquivo;

    public function setCaminhoRelativo($caminho){
        $this->caminhoRelativo = $caminho;
    }

    public function getCaminhoRelativo(){
        return $this->caminhoRelativo;
    }

    
    public function headerArquivo(){
        if (isset($this->estruturas[0]['CDBANCO']) && $this->cdbanco == $this->estruturas[0]['CDBANCO']) {
            $this->preparaArquivo();
            //CONTROLE
            $campoCodBan        = '237';
            $campoLote          = '0000';
            $campoCodReg        = '0';
            $campoReser1        = $this->completaCaracter(' ',9, ' ');
            //EMPRESA
            $campoTpEmpresa     = '2';  //'0'-> Isento / Não Informado  '1'-> CPF  '2'-> CGC / CNPJ  '3'-> PIS / PASEP  '9'-> Outro
            $campoNrEmpresa     = $this->retornaNum($this->estruturas[0]['CDCNPJESTRUT']);
            $campoCodConvenio   = $this->completaCaracter($this->codconvenio, 20, ' '); //Código do convênio
            $campoAgencia       = $this->completaCaracter($this->estruturas[0]['CDAGENCIA'], 5, '0', false);
            $campoCodAgencia    = ' ';
            
            if($this->nrorg == 1369){
                $campoCodAgencia = '5';
                $nmrazsocestrut = substr($this->estruturas[0]['NMRAZSOCESTRUT'], 0, -3);
            }
            
            $campoContaCorrente = $this->completaCaracter(substr($this->estruturas[0]['CDCONTCORR'], 0, -1), 12, '0', false); //Conta corrente
            $campoDigCon        = $this->completaCaracter(substr($this->estruturas[0]['CDCONTCORR'], -1), 1, '0'); //Dígito
            $campoDigAgCon      = ' ';
            $campoNomEmp        = $this->completaCaracter($this->estruturas[0]['NMRAZSOCESTRUT'], 30, ' ', true);
            $campoNomEmp = $this->nrorg == 1369 ? $this->completaCaracter($nmrazsocestrut, 30, ' ', true) :  $this->completaCaracter($this->estruturas[0]['NMRAZSOCESTRUT'], 30, ' ', true);
            $campoNomBan        = $this->completaCaracter('BRADESCO', 30, ' ');
            $campoReser2        = $this->completaCaracter(' ',10, ' ');
            //ARQUIVO
            $campoCodRem        = '1'; //'1' -> Remessa (Cliente Banco)  '2' -> Retorno (Banco Cliente)
            $campoDtGrav        = date('dmY'); 
            $campoHrGrav        = date('His');
            $campoSequen        = $this->completaCaracter('1', 6, '0', false);
            $campoLayout        = '089';
            $campoDensid        = '01600';
            $campoReser3        = $this->completaCaracter(' ', 20, ' ');
            $campoReser4        = $this->completaCaracter(' ', 20, ' ');
            $campoReser5        = $this->completaCaracter(' ', 29, ' ');
            
            
            $this->bufferSaida = $campoCodBan.$campoLote.$campoCodReg.$campoReser1.$campoTpEmpresa.$campoNrEmpresa.$campoCodConvenio
            .$campoAgencia.$campoCodAgencia.$campoContaCorrente.$campoDigCon.$campoDigAgCon.$campoNomEmp.$campoNomBan.$campoReser2
            .$campoCodRem.$campoDtGrav.$campoHrGrav.$campoSequen.$campoLayout.$campoDensid.$campoReser3.$campoReser4.$campoReser5."\r\n";            
            $this->bufferSaida = $this->remove_utf8_bom($this->bufferSaida);
            
            FPA::escreveArquivo($this->nomeArquivo, $this->bufferSaida);
            
            //Verifica se deve gerar os registros no magnético
            if($this->idgerameiomag == 'S' && $this->idteste == 'N') {
                $this->gravaLinhaNoMagnetico();
            }

        } else {
            throw new \Exception('Estrutura não possui conta corrente para o banco informado.');
        }
    }
    
    public function headerLote(){
        
        $campoCodBan        = '237';
        $campoLote          = '0001';
        $campoCodReg        = '1';
        $campoCodOper       = 'C';
        $campoTpServi       = '30'; //Pagamento Salários
        $campoFormaLanc     = '01'; //Crédito em Conta Corrente
        $campoLayout        = '045';
        $campoReser1        = ' ';
        //EMPRESA
        $campoTpEmpresa     = '2';  //'0'-> Isento / Não Informado  '1'-> CPF  '2'-> CGC / CNPJ  '3'-> PIS / PASEP  '9'-> Outro
        $campoNrEmpresa     = $this->retornaNum($this->estruturas[0]['CDCNPJESTRUT']);
        $campoCodConvenio   = $this->completaCaracter($this->codconvenio, 20, ' ');
        $campoAgencia       = $this->completaCaracter($this->estruturas[0]['CDAGENCIA'], 5, '0', false);
        $campoCodAgencia    = ' ';
        
        if($this->nrorg == 1369){
            $campoCodAgencia = '5';
            $nmrazsocestrut = substr($this->estruturas[0]['NMRAZSOCESTRUT'], 0, -3);
        }

        $campoContaCorrente = $this->completaCaracter(substr($this->retornaNum($this->estruturas[0]['CDCONTCORR']), 0, -1), 12, '0', false); //Conta corrente
        $campoDigCon        = $this->completaCaracter(substr($this->retornaNum($this->estruturas[0]['CDCONTCORR']), -1), 1, '0'); //Dígito
        $campoDigAgCon      = ' ';
        $campoNomEmp        = $this->completaCaracter($this->estruturas[0]['NMRAZSOCESTRUT'], 30, ' ', true);
        $campoNomEmp = $this->nrorg == 1369 ? $this->completaCaracter($nmrazsocestrut, 30, ' ', false) :  $this->completaCaracter($this->estruturas[0]['NMRAZSOCESTRUT'], 30, ' ', true);
        $campoInform1       = $this->completaCaracter(' ', 40, ' ');
        //ENDEREÇO DA EMPRESA
        $campoLogradouro    = $this->completaCaracter($this->estruturas[0]['LOGRADOURO'].' '.$this->estruturas[0]['ENDERECO'], 30, ' ', true);
        $campoNumero        = $this->completaCaracter($this->estruturas[0]['NRO'], 5, '0', false);
        $campoComplemento   = $this->completaCaracter($this->estruturas[0]['COMPLEMENTO'], 15, ' ', true);
        $campoCidade        = $this->completaCaracter($this->estruturas[0]['MUNICIPIO'], 20, ' ', true);
        $campoCEP           = substr($this->retornaNum($this->estruturas[0]['CEP']),0,5);
        $campoCompleCEP     = substr($this->retornaNum($this->estruturas[0]['CEP']),5,3);
        $campoEstado        = $this->estruturas[0]['UF'];
        $campoIndicativo    = '01';
        $campoReser2        = $this->completaCaracter(' ', 6, ' ');
        $campoReser3        = $this->completaCaracter(' ', 10, ' ');
        
        $this->bufferSaida = $campoCodBan.$campoLote.$campoCodReg.$campoCodOper.$campoTpServi.$campoFormaLanc.$campoLayout.$campoReser1
        .$campoTpEmpresa.$campoNrEmpresa.$campoCodConvenio.$campoAgencia.$campoCodAgencia.$campoContaCorrente.$campoDigCon.$campoDigAgCon
        .$campoNomEmp.$campoInform1.$campoLogradouro.$campoNumero.$campoComplemento.$campoCidade.$campoCEP.$campoCompleCEP.$campoEstado
        .$campoIndicativo.$campoReser2.$campoReser3."\r\n";
        $this->bufferSaida = $this->remove_utf8_bom($this->bufferSaida);
        
        FPA::escreveArquivo($this->nomeArquivo, $this->bufferSaida);
    
        //Verifica se deve gerar os registros no magnético
        if($this->idgerameiomag == 'S' && $this->idteste == 'N') {
            $this->gravaLinhaNoMagnetico();
        }
    }
    
    public function geraSegmentoA(){
        $campoCodBan        = '237';
        $campoLote          = '0001';
        $campoCodReg        = '3';
        // lembrar -> $contador
        $campoCodSegmento   = 'A';
        $campoTpMovimento   = '0';
        $campoCodInstru     = '00';
        //FAVORECIDO
        $campoCodCamara     = '000';

        if($this->nrorg == 3260){
            $campoCodInstru = '09';
        }
        
        $referenciaCnabAgenciaDV = $this->_valorReferencia->getValorReferencia('CNABAGENCIADV');
        $referenciaCnabBradescoX = $this->_valorReferencia->getValorReferencia('BRADESCO240X');
        
        foreach($this->vinculos as $vinculo){
            
            $nrFunc = $vinculo['NRVINCULOM'].$this->nrtipomoviment.FPA::getOcorrenciaCalculo();
            
            $campoNumSeq        = $this->completaCaracter(number_format($this->contador++, 0, '', ''), 5, '0', false);
            //CONTA CORRENTE
            $campoCodBan        = $this->completaCaracter($vinculo['CDBANCO'], 3, '0', false);
            $campoAgenci        = $this->completaCaracter($vinculo['CDAGENCIA'], 5, '0', false);
            $campoCodAgencia    = ' ';
            $campoNumCon        = $this->completaCaracter(substr($this->retornaNum($vinculo['CDCONTCORR']), 0, -1), 12, '0', false);
            $campoDigCon        = substr($this->retornaNum($vinculo['CDCONTCORR']), -1);
            $campoDigAgCon      = ' ';
            $campoNomFunc       = $this->completaCaracter($vinculo['NMVINCULOM'], 30, ' ');
            //CRÉDITO
            $campoNrFunc        = $this->completaCaracter($nrFunc , 20, ' ');
            $campoDtPgto        = $this->completaCaracter($this->retornaNum($this->dtpagamento), 8, '0', false);
            $campoTpMoeda       = 'BRL';
            $campoUniMoeda      = $this->completaCaracter('0', 15, '0', false);
            $campoVrPagto       = $this->completaCaracter(number_format($vinculo['VREVENTOFOLHA'], 2, '', ''), 15, '0', false);
            $campoNrFuncBanco   = $this->completaCaracter(' ', 20, ' ');
            $campoDtReal        = $this->completaCaracter('0', 8, '0');      // preenchido quando arquivo for de retorno
            $campoVrReal        = $this->completaCaracter('0', 15, '0');     // preenchido quando arquivo for de retorno
            //INFORMACOES
            $campoInform2       = $this->completaCaracter(' ', 40, ' ');
            $campoCdFinalDoc    = '06'; // 06-> Pagamento de Salários
            $campoCdFinalTed    = '00004';
            $campoFinalComple   = 'CC';
            
            $campoReser1        = $this->completaCaracter(' ', 3, ' ');
            $campoAviso         = '0';
            $campoOcorrencia    = $this->completaCaracter(' ', 10, ' ');
            
            if($this->nrorg == 3260){
                $campoCdFinalDoc    = $this->completaCaracter('0', 2, '0'); // 06-> Pagamento de Salários
                $campoCdFinalTed    = $this->completaCaracter('0', 5, '0');
                $campoFinalComple   = $this->completaCaracter('0', 2, '0');
            }
            
            if($this->nrorg == 1369 || ($referenciaCnabBradescoX && $referenciaCnabBradescoX == 1)){
                $campoFinalComple   = '  ';
                $campoCdFinalTed    = '03600';
            }
            
            if($referenciaCnabAgenciaDV && $referenciaCnabAgenciaDV == 1)
            {
                if(mb_strlen($vinculo['CDAGENCIA']) == 5){
                   $campoAgenci = substr($vinculo['CDAGENCIA'], 0, -1);
                   $campoAgenci = $this->completaCaracter($campoAgenci, 5, '0', false);
                   $campoCodAgencia = substr($vinculo['CDAGENCIA'], -1);
                }
            }
            
            $this->bufferSaida = $campoCodBan.$campoLote.$campoCodReg.$campoNumSeq.$campoCodSegmento.$campoTpMovimento.$campoCodInstru.$campoCodCamara.$campoCodBan
            .$campoAgenci.$campoCodAgencia.$campoNumCon.$campoDigCon.$campoDigAgCon.$campoNomFunc.$campoNrFunc.$campoDtPgto.$campoTpMoeda.$campoUniMoeda.$campoVrPagto
            .$campoNrFuncBanco.$campoDtReal.$campoVrReal.$campoInform2.$campoCdFinalDoc.$campoCdFinalTed.$campoFinalComple.$campoReser1.
            $campoAviso.$campoOcorrencia."\r\n";
            
            FPA::escreveArquivo($this->nomeArquivo, $this->bufferSaida);
			
			//Verifica se deve gerar os registros no magnético
            if($this->idgerameiomag == 'S') {
                $this->gravaLinhaNoMagnetico($vinculo['VREVENTOFOLHA'], $vinculo['NRVINCULOM']);
                
                if(!$this->_somenteAnalitico) { 
                    $this->setDtGerUltCNAB($vinculo['DTOCORRENCIA'], $vinculo['NRVINCULOM'], $vinculo['NRCALCULOFOLHA']); 
                }  
            } 
			
            $this->geraSegmentoB($vinculo);

        }
    }
    
    
    public function geraSegmentoB($vinculo){
        $campoCodBan        = '237';
        $campoLote          = '0001';
        $campoCodReg        = '3';
        // lembrar -> $contador
        $campoCodSegmento   = 'B';
        $campoReser1        = $this->completaCaracter(' ', 3, ' ');
        
        $campoTpFavorecido  = '1';
        /*foreach($this->vinculos as $vinculo){*/
            
        $campoNumSeq        = $this->completaCaracter(number_format($this->contador++, 0, '', ''), 5, '0', false);
        //FAVORECIDO
        $campoCPFunc        = $this->completaCaracter($this->retornaNum($vinculo['NRCPFPESSOA']), 14,'0',false);
        //ENDERECO
		if($this->nrorg == 3260){
            if(!$vinculo['SGESTADO']){
                $vinculo['SGESTADO'] = 'SP';
            }
            
            if(!$vinculo['NRCEPENDERECO']){
                $vinculo['NRCEPENDERECO'] = '03080010';
            }
        }
        $campoLogradouro    = $this->completaCaracter($vinculo['DSENDERECO'], 30, ' ', true);
        $campoNumero        = $this->completaCaracter($vinculo['NRIMOVELENDERECO'], 5, '0', false);
        $campoComplemento   = $this->completaCaracter($vinculo['COMPLEMENTO'], 15, ' ', true);
        $campoBairro        = $this->completaCaracter($vinculo['NMBAIRROENDERECO'], 15, ' ', true);
        $campoCidade        = $this->completaCaracter($vinculo['NMMUNICIPIO'], 20, ' ', true);
        $campoCEP           = substr($this->retornaNum($vinculo['NRCEPENDERECO']),0,5);
        $campoCompleCEP     = substr($this->retornaNum($vinculo['NRCEPENDERECO']),5,3);
        $campoEstado        = $vinculo['SGESTADO'];
        //PAGAMENTO
        $campoDtVenc        = $this->completaCaracter($this->retornaNum($this->dtpagamento), 8, '0', false);
        $campoValor         = $this->completaCaracter(number_format($vinculo['VREVENTOFOLHA'], 2, '', ''), 15, '0', false);
        $campoVrAbate       = $this->completaCaracter('0', 15, '0');
        $campoVrDesconto    = $this->completaCaracter('0', 15, '0');
        $campoVrMora        = $this->completaCaracter('0', 15, '0');
        $campoVrMulta       = $this->completaCaracter('0', 15, '0');
        $campoIdFavorecido  = $this->completaCaracter($vinculo['NRVINCULOM'], 15, ' ');
        $campoAviso         = '0';
        $campoCdUG          = $this->completaCaracter('0', 6, '0');
        $campoCdISPB        = $this->completaCaracter('0', 8, '0');
        
        $this->bufferSaida = $campoCodBan.$campoLote.$campoCodReg.$campoNumSeq.$campoCodSegmento.$campoReser1.$campoTpFavorecido.$campoCPFunc.$campoLogradouro.
        $campoNumero.$campoComplemento.$campoBairro.$campoCidade.$campoCEP.$campoCompleCEP.$campoEstado.$campoDtVenc.$campoValor.
        $campoVrAbate.$campoVrDesconto.$campoVrMora.$campoVrMulta.$campoIdFavorecido.$campoAviso.$campoCdUG.$campoCdISPB."\r\n";
        
        FPA::escreveArquivo($this->nomeArquivo, $this->bufferSaida);
        
		//Verifica se deve gerar os registros no magnético
		if($this->idgerameiomag == 'S') {
			$this->gravaLinhaNoMagnetico($vinculo['VREVENTOFOLHA'], $vinculo['NRVINCULOM']);
		}
        /*}*/
    }
    
    public function geraTrailerLote(){
        $campoCodBan        = '237';
        $campoLote          = '0001';
        $campoCodReg        = '5';
        $campoReser1        = $this->completaCaracter(' ', 9, ' ');
        
        //TOTAIS
        $campoQtdReg        = $this->completaCaracter($this->contador+1, 6, '0', false);
        $campoVrTotal       = $this->completaCaracter(number_format($this->vrtotal, 2, '', ''), 18, '0', false);
        $campoVrTotalMoeda  = $this->completaCaracter('0', 18, '0', false);
        
        $campoNrAvisoDebito = $this->completaCaracter('0', 6, '0');
        $campoReser2        = $this->completaCaracter(' ', 165, ' ');
        $campoOcorrencia    = $this->completaCaracter(' ', 10, ' ');

        $this->bufferSaida = $campoCodBan.$campoLote.$campoCodReg.$campoReser1.$campoQtdReg.$campoVrTotal.$campoVrTotalMoeda.
        $campoNrAvisoDebito.$campoReser2.$campoOcorrencia."\r\n";
            
        FPA::escreveArquivo($this->nomeArquivo, $this->bufferSaida);
        
        //Verifica se deve gerar os registros no magnético
        if($this->idgerameiomag == 'S' && $this->idteste == 'N') {
            $this->gravaLinhaNoMagnetico($vinculo['VREVENTOFOLHA'], $vinculo['NRVINCULOM']);
        }
    }
    
    public function geraTrailerArquivo(){
        $campoCodBan        = '237';
        $campoLote          = '9999';
        $campoCodReg        = '9';
        $campoReser1        = $this->completaCaracter(' ', 9, ' ');
        
        //TOTAIS
        $campoQtdLotes      = $this->completaCaracter( '1', 6, '0', false);
        $campoQtdRegs       = $this->completaCaracter( $this->contador+3, 6, '0', false);      //Somatória dos registros de tipo 0, 1, 3, 5 e 9
        $campoQtdContaConci = $this->completaCaracter('0', 6, '0');
        $campoReser2        = $this->completaCaracter(' ', 205, ' ');
        
        $this->bufferSaida = $campoCodBan.$campoLote.$campoCodReg.$campoReser1.$campoQtdLotes.$campoQtdRegs.$campoQtdContaConci.$campoReser2;
            
        FPA::escreveArquivo($this->nomeArquivo, $this->bufferSaida);
        
        //Verifica se deve gerar os registros no magnético
        if($this->idgerameiomag == 'S' && $this->idteste == 'N') {
            $this->gravaLinhaNoMagnetico();
        }
  
        $processamento = MsgCalculo::getInstance();
        $idstatus = $processamento->getDados()['IDSTATUS'];
        $idabort = $processamento->getDados()['IDABORT'];
        $msgcalculo = $processamento->getDados();
        $processamento->salvaMensagens();

        return array(
            'ARQUIVO' => ($idabort === true ? null : $this->nomeArquivo), 
            'CALCULO' => $this->nrCalculo,
            'MENSAGENS' => ($idabort === true ? $msgcalculo['MENSAGENS'] : null),
            'ERRO' => (($idstatus === MsgCalculo::ID_COM_ERRO) or ($idstatus === MsgCalculo::ID_COM_ALERTA)),			
            'ABORT' => false
        );
        
    }
 /*   
    public function geraCabecalho(){
        
        if (isset($this->estruturas[0]['CDBANCO']) && $this->cdbanco == $this->estruturas[0]['CDBANCO']) {
            $this->preparaArquivo();

            $this->contador = 2;

            $campoCodReg = '0';
            $campoCodRem = '1';
            $campoLiter1 = 'REMESSA';
            $campoCodSer = '03';
            $campoLiter2 = $this->completaCaracter('CREDITO C/C', 15, ' ');
            $campoIdenti = $this->completaCaracter($this->estruturas[0]['CDAGENCIA'], 5, '0', false);
            $campoRazaoS = $this->razaoConta($this->estruturas[0]['NRTPCONTCORR']);
            $campoEmpres = $this->completaCaracter(substr($this->estruturas[0]['CDCONTCORR'], 0, -1), 7, '0', false); //Conta corrente
            $campoNoBanc = $this->completaCaracter(substr($this->estruturas[0]['CDCONTCORR'], -1), 1, '0'); //Dígito
            $campoID     = ' ';
            $campoReser1 = ' ';
            $campoCodEmp = $this->completaCaracter($this->codconvenio, 5, ' '); //Código da empresa fornecido pelo banco
            $campoNomEmp = $this->completaCaracter($this->estruturas[0]['NMRAZSOCESTRUT'], 25, ' ', true);
            $campoCodBan = $this->completaCaracter($this->cdbanco, 3, '0', false);
            $campoNomBan = $this->completaCaracter('BRADESCO', 15, ' ');
            $campoDtGrav = date('dmY');
            $campoDensid = '01600';
            $campoLiter3 = 'BPI';
            // Alteracao do Marcelo 18-08-2014 referente ao formato incorreto da data de pgto do cnab bradesco
            $auxCampoDtDebi     = DateUtil::getDataDeString(substr($this->dtpagamento, 0, 10));
            
            $campoDtDebi = $auxCampoDtDebi->format('dmY');			

            $campoIdMoed = ' ';
            $campoIdSecu = 'N';
            $campoReser2 = $this->completaCaracter(' ', 74, ' ');
            $campoNumSeq = '000001'; //Número sequencila. Tratar se for ter mais cabeçalhos.

            $this->bufferSaida = $campoCodReg.$campoCodRem.$campoLiter1.$campoCodSer.$campoLiter2.$campoIdenti.
                $campoRazaoS.$campoEmpres.$campoNoBanc.$campoID.$campoReser1.$campoCodEmp.$campoNomEmp.
                $campoCodBan.$campoNomBan.$campoDtGrav.$campoDensid.$campoLiter3.$campoDtDebi.$campoIdMoed.
                $campoIdSecu.$campoReser2.$campoNumSeq."\r\n";
            $this->bufferSaida = $this->remove_utf8_bom($this->bufferSaida);
            
            FPA::escreveArquivo($this->nomeArquivo, $this->bufferSaida);
    
            //Verifica se deve gerar os registros no magnético
            if($this->idgerameiomag == 'S' && $this->idteste == 'N') {
                $this->gravaLinhaNoMagnetico();
            }
        } else {
            throw new \Exception('Estrutura não possui conta corrente para o banco informado.');
        }
    }

    public function geraRegistros(){
        $campoCodReg = '1';
        $campoReser1 = $this->completaCaracter(' ', 61, ' ');

        $campoReser2 = $this->completaCaracter(' ', 2, ' ');

        $campoCodSer = '298';
        $campoReser3 = $this->completaCaracter(' ', 8, ' ');
        $campoReser4 = $this->completaCaracter(' ', 44, ' ');

        foreach($this->vinculos as $vinculo){
            $campoAgenci = $this->completaCaracter($vinculo['CDAGENCIA'], 5, '0', false);
            $campoRazCon = $this->razaoConta($vinculo['NRTPCONTCORR']);
            $campoNumCon = $this->completaCaracter(substr($vinculo['CDCONTCORR'], 0, -1), 7, '0', false);
            $campoDigCon = substr($vinculo['CDCONTCORR'], -1);

            $campoNomFun = $this->completaCaracter($vinculo['NMVINCULOM'], 38, ' ');
            $campoCodFun = $this->completaCaracter($vinculo['CDMATRICULA'], 6, '0', false);
            $campoValor  = $this->completaCaracter(number_format($vinculo['VREVENTOFOLHA'], 2, '', ''), 13, '0', false);

            $campoNumSeq = $this->completaCaracter(number_format($this->contador++, 0, '', ''), 6, '0', false);

            $this->bufferSaida = $campoCodReg.$campoReser1.$campoAgenci.$campoRazCon.$campoNumCon.$campoDigCon.
                $campoReser2.$campoNomFun.$campoCodFun.$campoValor.$campoCodSer.$campoReser3.$campoReser4.
                $campoNumSeq."\r\n";
            
            FPA::escreveArquivo($this->nomeArquivo, $this->bufferSaida);

            //Verifica se deve gerar os registros no magnético
            if($this->idgerameiomag == 'S' && $this->idteste == 'N') {
                $this->gravaLinhaNoMagnetico($vinculo['VREVENTOFOLHA'], $vinculo['NRVINCULOM']);
            }
        }
    }

   *
     * Gera o rodapé do CNAB. Fecha o arquivo. Inicia o download do mesmo
     *
    public function geraRodape(){
        $campoCodReg = '9';
        $campoTotVal = $this->completaCaracter(number_format($this->vrtotal, 2, '', ''), 13, '0', false);
        $campoReserv = $this->completaCaracter(' ', 180, ' ');
        $campoNumSeq = $this->completaCaracter(number_format($this->contador, 0, '', ''), 6, '0', false);

        $this->bufferSaida = $campoCodReg.$campoTotVal.$campoReserv.$campoNumSeq;
        
        FPA::escreveArquivo($this->nomeArquivo, $this->bufferSaida);    
        
        //Verifica se deve gerar os registros no magnético
        if($this->idgerameiomag == 'S' && $this->idteste == 'N') {
            $this->gravaLinhaNoMagnetico();
        }
        
        return array(
            'ARQUIVO' => $this->nomeArquivo,
            'CALCULO' => null,
            'MENSAGENS' => null,
            'ERRO' => null,
            'ABORT' => null
        );
    }

*/
    /*
     * De - Para para o tipo de conta
     */
    protected function razaoConta($tipoConta){
        switch($tipoConta){
            case '3':
            case '1':
                return '07050';
            case '2':
            //case '3':
                return '07380';
            default:
                return '00000';
        }
    }

    /*
     * Cria a estrutura de pastas do caminho relativo se necessário.
     * Exclui todos os arquivos da pasta relativa.
     * Gera o nome do arquivo com o caminho relativo para o novo cnab considerando a data e o número sequencial.
     *
     */
    private function preparaArquivo(){

        //Inicio da montagem do nome do arquivo
        $this->nomeArquivo = 'FP'.date('dm');

        $form = new FpaFormcnabEntity($this->entityManager, $this->hcmParameters);
        $dadosFormulario = $form->retornaDadosFormularioCNAB($this->nrorg, $this->nrformcnab);
        $data = $dadosFormulario->getDtultimocnab();
        $nro  = $dadosFormulario->getNrultimocnab();

        //Número sequencial do arquivo, de 0 a 9
        if($data == date('d/m/Y 00:00:00'))
        {
            ++$nro;
            if($nro > 9)
                $nro = 0;
        } else {
            $data = date('dmY');
            $nro = 0;
        }
        
        $sequenciaBradesco = 'BRADESCO'.$data;
        $nro = \HCM\Util\NovoCodigo::geraCodigo($this->hcmParameters->getNrorgTrabalho(), $sequenciaBradesco, 1, 12, true);
        
        $this->nomeArquivo .= $nro;
        $this->nrSeqArquvio = $nro;
        
        //Extensão do arquivo
        if($this->idteste == 'S')
            $this->nomeArquivo .= '.TST';
        else if($this->idtxt == 'S')
            $this->nomeArquivo .= '.TXT';
        else
            $this->nomeArquivo .= '.REM';

        //Grava a data e o número sequencial do cnab gerado no formulário
        // $dadosFormulario->setDtultimocnab($data);
        $dadosFormulario->setDtultimocnab(DateUtil::getDataDeString(date('dmY'), DateUtil::FORMATO_BRASILEIRO, true));
        $dadosFormulario->setNrultimocnab($nro);
        $this->entityManager->persist($dadosFormulario);
        $this->entityManager->flush($dadosFormulario);
    }

    public function getNomeArquivoGerado(){
        return $this->nomeArquivo;
    }

    public function gravaLinhaNoMagnetico($valor = null, $nrvinculom = null){
        $magnetico = new FpaCnabmagnetEntity($this->entityManager, $this->hcmParameters);

        //verificar se já tem uma data igual a esta e retroceder se tiver
        //Armazenar o CNAB
        //$teste = new \FpaCnab

        $magnetico->insereRegistroLista($this->nrorg, $this->cdOperador, $this->competencia, null, $this->idtpinscrespons,
            $this->estruturas[0]['CDCNPJESTRUT'], $this->bufferSaida, $this->cdbanco, $this->nrtipomoviment,
            $this->nrSeqArquvio, $valor, $nrvinculom);

        $magnetico->persist();
    }
}