<?php

namespace HCM\FPA\Services;

use HCM\FPA\Repository\RelatCustomPensionistaRepository;
use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;


class RelatCustomPensionistaService {
    /** @var EntityManager */
    protected $entityManager;

     /**
     * @var relatCustomPensionistaRepository
     */
    protected $relatCustomPensionistaRepository;

     /** @var HCMParameters */
     protected $hcmParameters;

    public function __construct(
        EntityManager $entityManager,
        RelatCustomPensionistaRepository $relatCustomPensionistaRepository,
        HcmParameters   $hcmParameters
    ) {
        $this->entityManager = $entityManager;
        $this->relatCustomPensionistaRepository = $relatCustomPensionistaRepository;
        $this->hcmParameters = $hcmParameters;
        $this->_nrTipoModalidadeCalculo = $hcmParameters->getTipoModalidadeCalculo();
        $this->_nrOcorrenciaCalculo = $hcmParameters->getNrOcorrenciaCalculo();
    }

    public function getRelatCustomPensionista($filters) {
        $parameters = array(
            'P_NRORG'                   => '',
            'P_NRORG_PADRAO'            => '',
            'P_DTMESCOMPETENC'          => '',
            'P_NRESTRUTLEGAL'           => '',
            'P_NRESTRUTGEREN'           => '',
            'P_NRVINCULOM'              => '',
            'P_NROCORRECAL'             => $this->hcmParameters->getNrOcorrenciaCalculo(),
            'P_NRTPMODALIDCAL'          => $this->hcmParameters->getTipoModalidadeCalculo(),
            'P_DTVENCIMENTO'            => '',
            'P_NRTIPOMOVIMENT'          => '',
            "P_NRTIPOESTRUTOMADOR"      => $this->hcmParameters->getTipoEstruturaTomadorOrg(),
            );
           
            foreach ($filters as $filter) {
                switch($filter['columnName']){
                    case 'P_NRORG':                   $parameters['P_NRORG']                   = $filter['value']; break;
                    case 'P_NRORG_PADRAO':            $parameters['P_NRORG_PADRAO']            = $filter['value']; break;
                    case 'P_DTMESCOMPETENC':          $parameters['P_DTMESCOMPETENC']          = $filter['value']; break;
                    case 'NRESTRUTLEGAL_LIST':        $parameters['P_NRESTRUTLEGAL']           = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                    case 'NRESTRUTGEREN_LIST':        $parameters['P_NRESTRUTGEREN']           = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                    case 'NRVINCULOM_LIST':           $parameters['P_NRVINCULOM']              = is_array( $filter['value'] ) ? implode( $filter['value'], ',' ) : $filter['value']; break;
                    case 'DTVENCIMENTO':              $parameters['P_DTVENCIMENTO']            = $filter['value']; break;
                    case 'NRTIPOMOVIMENT':            $parameters['P_NRTIPOMOVIMENT']          = $filter['value']; break;
                }
            }


        return $this->relatCustomPensionistaRepository->getRelatCustomPensionista($parameters);
      }
  
}