<?php
namespace HCM\Geral\Repository;

use Doctrine\DBAL\Connection;

class EnviarMensagemRepository {

    protected  $connection;
    public function __construct(Connection $connection) {
        $this->connection = $connection;
    }

    /**
     * @return array
     */
    public function getEstruturaProcesso($nrorgEstru, $nrprocesso) {
        $estruturaQuery = "SELECT NVL(NMFANTASIA, NMESTRUTURAM) NMFANTASIA, NMPROCESSO 
                            FROM DES_PROCESSO P 
                            JOIN ESTRUTURAM E
                              ON P.NRESTRUTGEREN = E.NRESTRUTURAM
                            JOIN ESTRUTURAH H
                              ON E.NRESTRUTURAM = H.NRESTRUTURAM
                           WHERE (NRPROCESSO = '$nrprocesso')  AND (P.NRORG = '$nrorgEstru')";
        return $this->connection->fetchAll($estruturaQuery);
    }

    public function getOperador($nrorg, $cdoperador) {
        $operadorQuery = "SELECT NMOPERADOR, DSEMAILOPER FROM OPERADOR O
                              JOIN PARCNEGOCIO P 
                                ON O.NRPARCNEGOCIO = P.NRPARCNEGOCIO 
                               AND O.NRORG = P.NRORG
                            WHERE CDOPERADOR = $cdoperador AND O.NRORG = $nrorg";
        return $this->connection->fetchAll($operadorQuery);
    }

    public function getOperadorParcnegocio($nrorg, $nrparcnegocio) {
        $operadorParcnegocioQuery = "SELECT DISTINCT INITCAP(O.NMOPERADOR) NMOPERADOR, O.DSEMAILOPER
                         FROM OPERADOR O
                         JOIN PARCNEGOCIO P
                           ON O.NRPARCNEGOCIO = P.NRPARCNEGOCIO
                        WHERE (O.NRPARCNEGOCIO = '$nrparcnegocio') AND (O.NRORG = '$nrorg')";
        return $this->connection->fetchAll($operadorParcnegocioQuery);
    }

    public function getOperadorVinculo($nrorg, $nrvinculom) {
        $operadorVinculoQuery = "SELECT INITCAP(OP.NMOPERADOR) NMOPERADOR, OP.DSEMAILOPER 
                                   FROM GPE_VINCULOM VM
                                   JOIN GPE_PESSOA P
                                     ON P.NRPESSOA = VM.NRPESSOA
                                    AND P.NRORG = VM.NRORG
                                   JOIN OPERADOR OP
                                     ON OP.NRPARCNEGOCIO = P.NRPARCNEGOCIO
                                    AND OP.NRORG = P.NRORG
                                  WHERE VM.NRORG = $nrorg 
                                    AND VM.NRVINCULOM = $nrvinculom";
        $result = $this->connection->fetchAll($operadorVinculoQuery);

        if (empty($result)) {
           $result = self::getEmailComunicacao($nrorg, $nrvinculom);
        }                            

        return $result;
    }

     public function getEmailComunicacao($nrorg, $nrvinculom) {
        $operadorVinculoQuery = "SELECT CDCOMUNICAPARC, NMPRINCIPALPARC
                                   FROM COMUNICAPARC 
                                   JOIN PARCNEGOCIO
                                     ON PARCNEGOCIO.NRPARCNEGOCIO = COMUNICAPARC.NRPARCNEGOCIO
                                    AND PARCNEGOCIO.NRORG         = COMUNICAPARC.NRORG
                                  WHERE COMUNICAPARC.NRPARCNEGOCIO IN (SELECT NRPARCNEGOCIO 
                                                            FROM GPE_VINCULOM
                                                            JOIN GPE_PESSOA
                                                              ON GPE_PESSOA.NRPESSOA = GPE_VINCULOM.NRPESSOA
                                                             AND GPE_PESSOA.NRORG    = GPE_VINCULOM.NRORG
                                                           WHERE GPE_PESSOA.NRORG = '$nrorg'
                                                             AND NRVINCULOM       = '$nrvinculom') 
                                    AND COMUNICAPARC.CDFORMACOMU = '05' AND COMUNICAPARC.NRORG = '$nrorg'";
            
        return $this->connection->fetchAll($operadorVinculoQuery);
    }
} 

