<?php
namespace Service\Hcm;

class EscalaService {

    private $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager)
    {
        $this->entityManager = $entityManager;
    }

    public function getAlteracoesEscala($dtinicio, $dtfim, $nrvinculom, $dtmescompetencia, $nrorg, $nrestrutlegal, $cdcnpjestrut) {
        try {
            $query = <<<SQL
SELECT
    TO_CHAR(AE.DTINIESCALA, 'D') ID_DIA_DTINIESCALA,
    AE.*,
    VM.CDMATRICULA,
    ESTRUTLEGAL.NMESTRUTURAM AS NMESTRUTLEGAL,
    ESTRUTLEGAL.NRESTRUTURAM AS NRESTRUTLEGAL,
    ESTRUTLEGAL.CDINTESTRUTURA AS CDINTESTRUTLEGAL,
    ESTRUTLEGALH.CDCNPJESTRUT AS CNPJESTRUTLEGAL,
    ESTRUTGEREN.NMESTRUTURAM AS NMESTRUTGEREN,
    ESTRUTGEREN.NRESTRUTURAM AS NRESTRUTGEREN,
    ESTRUTGEREN.CDINTESTRUTURA AS CDINTESTRUTGEREN
FROM
         GPE_ALTEESCALA AE
    JOIN GPE_VINCULOM VM ON VM.NRVINCULOM = AE.NRVINCULOM
                            AND VM.NRORG = AE.NRORG
    JOIN GPE_VINCULOH VH ON VH.NRVINCULOM = VM.NRVINCULOM
                            AND VH.NRORG = VM.NRORG
                            AND VH.DTMESCOMPETENC = ( SELECT * 
                                FROM (
                                    SELECT
                                        DTMESCOMPETENC
                                    FROM
                                        GPE_VINCULOH 
                                    WHERE
                                        NRVINCULOM = VH.NRVINCULOM
                                        AND NRORG = VH.NRORG
                                        AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                    ORDER BY DTMESCOMPETENC DESC
                                )
                                WHERE ROWNUM=1
                            )
    LEFT JOIN ESTRUTURAM ESTRUTLEGAL ON ESTRUTLEGAL.NRESTRUTURAM = VH.NRESTRUTLEGAL 
                         AND ESTRUTLEGAL.NRORG = VH.NRORG 
    LEFT JOIN ESTRUTURAH   ESTRUTLEGALH ON ESTRUTLEGAL.NRESTRUTURAM = ESTRUTLEGALH.NRESTRUTURAM
                            AND ESTRUTLEGAL.NRORG = ESTRUTLEGALH.NRORG
                            AND ESTRUTLEGALH.DTMESCOMPETENC = ( SELECT *
                                FROM (
                                    SELECT
                                        DTMESCOMPETENC
                                    FROM
                                        ESTRUTURAH
                                    WHERE
                                        NRORG = ESTRUTLEGALH.NRORG
                                        AND NRESTRUTURAM = ESTRUTLEGALH.NRESTRUTURAM
                                        AND DTMESCOMPETENC <= :P_DTMESCOMPETENC
                                    ORDER BY DTMESCOMPETENC DESC
                                )
                                WHERE ROWNUM=1
                            )
    LEFT JOIN ESTRUTURAM ESTRUTGEREN ON ESTRUTGEREN.NRESTRUTURAM = VH.NRESTRUTGEREN 
                         AND ESTRUTGEREN.NRORG = VH.NRORG
WHERE
    AE.NRORG = :P_NRORG
    AND (
            ((:P_DTINICIO IS NULL OR AE.DTINIESCALA >= :P_DTINICIO) AND (:P_DTFIM IS NULL OR AE.DTINIESCALA <= :P_DTFIM)) 
            OR ((:P_DTINICIO IS NULL OR AE.DTFIMESCALA >= :P_DTINICIO) AND (:P_DTFIM IS NULL OR AE.DTFIMESCALA <= :P_DTFIM))
        )
    AND ( :P_NRVINCULOM IS NULL OR INSTR(',' || :P_NRVINCULOM || ',', ',' || VM.NRVINCULOM || ',') > 0 )
    AND ( ESTRUTLEGAL.NRESTRUTURAM = :P_NRESTRUTURAM OR :P_NRESTRUTURAM IS NULL )
    AND ( ESTRUTLEGALH.CDCNPJESTRUT = :P_CDCNPJESTRUT OR :P_CDCNPJESTRUT IS NULL)
SQL;
            $params = array(
                'P_DTMESCOMPETENC' => $dtmescompetencia,
                'P_NRVINCULOM' => $nrvinculom,
                'P_DTINICIO' => $dtinicio,
                'P_DTFIM' => $dtfim,
                'P_NRORG' => $nrorg,
                'P_NRESTRUTURAM' => $nrestrutlegal, 
                'P_CDCNPJESTRUT' => $cdcnpjestrut
            );
            return $this->entityManager->getConnection()->fetchAll($query, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

}