CREATE OR REPLACE PROCEDURE CALCULA_IMPOSTO_COMBUSTIVEL(
   P_CDFILIAL VARCHAR2,
   P_NRLANCTONF VARCHAR2,
   P_ENTRSAID VARCHAR2,
   P_IDPERVISIMPSCRE VARCHAR2,
   P_CLIENTE VARCHAR2,
   P_PAISORIG VARCHAR2,
   P_ESTAORIG VARCHAR2)
IS
   V_DSINFADICPROD VARCHAR2(4000);
   V_BCMONO FLOAT;                                         
   V_ALIQMONO FLOAT;
   V_ICMSMONO FLOAT;
   V_BCMONORET FLOAT;
   V_ALIQMONORET FLOAT;
   V_ICMSMONORET FLOAT;
   V_REDUCAO FLOAT;
   V_ALIQREDUCAO FLOAT;
   V_VRPERDIFERE FLOAT;
   V_PERDIFERE FLOAT;
   V_ICMSMONOOP FLOAT;
   V_ICMSMONODIF FLOAT;
   V_IDDIFECLI VARCHAR2(1);
BEGIN
   V_BCMONO := 0;
   V_ALIQMONO := 0;
   V_ICMSMONO := 0;
   V_BCMONORET := 0;
   V_ALIQMONORET := 0;
   V_ICMSMONORET := 0;
   V_ALIQREDUCAO := 0;
   V_VRPERDIFERE := 0;
   V_ICMSMONOOP := 0;
   V_ICMSMONODIF := 0;
   /*Sada*/
   IF P_ENTRSAID = 'S' THEN
      FOR C_ITEM IN (SELECT IP.NRSEQITPROD, NVL(VRALIQICMSMONORET, 0) AS ALIQMONORET, NVL(VRALIQICMSMONO, 0) AS ALIQMONO,
                            NVL(VRPERCMISTURA, 0) AS REDUCAO, QTITEMPROD, SGUNIDADETRIB, NVL(VRFATOCONVUNTRIB, 1) AS FATORCONVERSAO,
                            IT.CDIMPOSTO, SUBSTR(IP.CDSITUTRIBPR, 2, 2) AS CST, P.CDARVPROD
                       FROM ITEMPRODUTO IP, ITEMPROIMPOS IT, PRODUTO P, IMPOSTO I
                      WHERE IP.CDFILIAL = P_CDFILIAL
                        AND IP.NRLANCTONF = P_NRLANCTONF
                        AND IP.CDFILIAL = IT.CDFILIAL
                        AND IP.NRLANCTONF = IT.NRLANCTONF
                        AND IP.NRSEQITPROD = IT.NRSEQITPROD
                        AND IT.CDIMPOSTO = I.CDIMPOSTO
                        AND I.CDIMPOSTONFE = '00'
                        AND SUBSTR(IP.CDSITUTRIBPR, 2, 2) IN ('02', '15', '53', '61')
                        AND P.CDPRODUTO = IP.CDPRODUTO) LOOP
          IF C_ITEM.CST = '02' THEN
             IF C_ITEM.ALIQMONO > 0 THEN
                V_BCMONO := C_ITEM.QTITEMPROD * C_ITEM.FATORCONVERSAO;
                V_ALIQMONO := C_ITEM.ALIQMONO;
                V_ICMSMONO := V_BCMONO * C_ITEM.ALIQMONO;
             ELSE
                V_BCMONO := 0;
                V_ALIQMONO := 0;
                V_ICMSMONO := 0;
             END IF;
             IF V_ICMSMONO > 0 THEN
                V_DSINFADICPROD := 'ICMS monofsico prprio: BC '||TRIM(TO_CHAR(ROUND(V_BCMONO, 2), '9999999999999.99'))||
                                   ' (em litros); Alquota: R$ '||TRIM(TO_CHAR(ROUND(C_ITEM.ALIQMONO, 2), '9999999999999.99'))||
                                   '; ICMS mono: R$ '||TRIM(TO_CHAR(ROUND(V_ICMSMONO, 2), '9999999999999.99'));
             END IF;
          ELSIF C_ITEM.CST = '15' THEN
             IF C_ITEM.REDUCAO > 0 THEN
                V_ALIQREDUCAO := C_ITEM.REDUCAO;
                V_REDUCAO := (100 - C_ITEM.REDUCAO) / 100;
                IF C_ITEM.ALIQMONO > 0 THEN
                   V_BCMONO := C_ITEM.QTITEMPROD * C_ITEM.FATORCONVERSAO * V_REDUCAO;
                   V_ALIQMONO := C_ITEM.ALIQMONO;
                   V_ICMSMONO := V_BCMONO * C_ITEM.ALIQMONO;
                ELSE
                   V_BCMONO := 0;
                   V_ALIQMONO := 0;
                   V_ICMSMONO := 0;
                END IF;
                IF C_ITEM.ALIQMONORET > 0 THEN
                   V_BCMONORET := (C_ITEM.QTITEMPROD * C_ITEM.FATORCONVERSAO) - V_BCMONO;
                   V_ALIQMONORET := C_ITEM.ALIQMONORET;
                   V_ICMSMONORET := V_BCMONORET * C_ITEM.ALIQMONORET;
                ELSE
                   V_BCMONORET := 0;
                   V_ALIQMONORET := 0;
                   V_ICMSMONORET := 0;
                END IF;
             ELSE
                IF C_ITEM.ALIQMONO > 0 THEN
                   V_BCMONO := C_ITEM.QTITEMPROD * C_ITEM.FATORCONVERSAO;
                   V_ICMSMONO := V_BCMONO * C_ITEM.ALIQMONO;
                ELSE
                   V_BCMONO := 0;
                   V_ICMSMONO := 0;
                END IF;
                IF C_ITEM.ALIQMONORET > 0 THEN
                   V_BCMONORET := C_ITEM.QTITEMPROD * C_ITEM.FATORCONVERSAO;
                   V_ICMSMONORET := V_BCMONORET * C_ITEM.ALIQMONORET;
                ELSE
                   V_BCMONORET := 0;
                   V_ICMSMONORET := 0;
                END IF;
             END IF;
             IF V_ICMSMONO > 0 THEN
                V_DSINFADICPROD := 'ICMS monofsico prprio: BC '||TRIM(TO_CHAR(ROUND(V_BCMONO, 2), '9999999999999.99'))||
                                   ' (em litros); Alquota: R$ '||TRIM(TO_CHAR(ROUND(C_ITEM.ALIQMONO, 2), '9999999999999.99'))||
                                   '; ICMS mono: R$ '||TRIM(TO_CHAR(ROUND(V_ICMSMONO, 2), '9999999999999.99'));
             END IF;
             IF V_ICMSMONORET > 0 THEN
                V_DSINFADICPROD := 'ICMS monofsico sujeito a reteno: BC '||TRIM(TO_CHAR(ROUND(V_BCMONORET, 2), '9999999999999.99'))||
                                   ' (em litros); Alquota: R$ '||TRIM(TO_CHAR(ROUND(C_ITEM.ALIQMONORET, 2), '9999999999999.99'))||
                                   '; ICMS mono: R$ '||TRIM(TO_CHAR(ROUND(V_ICMSMONORET, 2), '9999999999999.99'));
             END IF;
          ELSIF C_ITEM.CST = '53' THEN
             BEGIN
                SELECT PD.VRPERDIFERE, 'S'
                  INTO V_VRPERDIFERE, V_IDDIFECLI
                  FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                 WHERE PD.CDPRODUTO = PR.CDPRODUTO
                   AND PD.CDPAIS = P_PAISORIG
                   AND PD.SGESTADO = P_ESTAORIG
                   AND PD.CDCLIENTE = P_CLIENTE
                   AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                          FROM PRODDIFEREIMPCLI PD, PRODUTO PR
                                         WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                           AND PD.CDPAIS = P_PAISORIG
                                           AND PD.SGESTADO = P_ESTAORIG
                                           AND PD.CDCLIENTE = P_CLIENTE
                                           AND INSTR(NVL(RTRIM(C_ITEM.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_VRPERDIFERE := 0; V_IDDIFECLI := 'N';
             END;

             IF V_IDDIFECLI = 'N' THEN
                BEGIN
                   SELECT PD.VRPERDIFERE
                     INTO V_VRPERDIFERE
                     FROM PRODDIFEREIMPOS PD, PRODUTO PR
                    WHERE PD.CDPRODUTO = PR.CDPRODUTO
                      AND PD.CDPAIS = P_PAISORIG
                      AND PD.SGESTADO = P_ESTAORIG
                      AND PR.CDARVPROD IN (SELECT MAX(PR.CDARVPROD) AS CDARVPROD
                                             FROM PRODDIFEREIMPOS PD, PRODUTO PR
                                            WHERE PD.CDPRODUTO = PR.CDPRODUTO
                                              AND PD.CDPAIS = P_PAISORIG
                                              AND PD.SGESTADO = P_ESTAORIG
                                              AND INSTR(NVL(RTRIM(C_ITEM.CDARVPROD), PR.CDARVPROD), PR.CDARVPROD) = 1);
                EXCEPTION
                   WHEN NO_DATA_FOUND THEN
                      V_VRPERDIFERE := 0;
                END;
             END IF;
             IF C_ITEM.ALIQMONO > 0 AND V_VRPERDIFERE > 0 THEN
                V_BCMONO := C_ITEM.QTITEMPROD * C_ITEM.FATORCONVERSAO;
                V_ALIQMONO := C_ITEM.ALIQMONO;
                V_ICMSMONOOP := V_BCMONO * C_ITEM.ALIQMONO;
                V_ICMSMONODIF := V_ICMSMONOOP * (V_VRPERDIFERE / 100);
                V_ICMSMONO := V_ICMSMONOOP - V_ICMSMONODIF;
             ELSE
                V_BCMONO := 0;
                V_ALIQMONO := 0;
                V_ICMSMONOOP := 0;
                V_ICMSMONO := 0;
                V_ICMSMONO := 0;
             END IF;
             IF V_ICMSMONO > 0 THEN
                V_DSINFADICPROD := 'ICMS monofsico diferido: BC '||TRIM(TO_CHAR(ROUND(V_BCMONO, 2), '9999999999999.99'))||
                                   ' (em litros); Alquota: R$ '||TRIM(TO_CHAR(ROUND(C_ITEM.ALIQMONO, 2), '9999999999999.99'))||
                                   '; ICMS mono: R$ '||TRIM(TO_CHAR(ROUND(V_ICMSMONO, 2), '9999999999999.99'));
             END IF;
          ELSIF C_ITEM.CST = '61' THEN
             IF C_ITEM.ALIQMONO > 0 THEN
                V_BCMONO := C_ITEM.QTITEMPROD * C_ITEM.FATORCONVERSAO;
                V_ALIQMONO := C_ITEM.ALIQMONO;
                V_ICMSMONO := V_BCMONO * C_ITEM.ALIQMONO;
             ELSE
                V_BCMONO := 0;
                V_ALIQMONO := 0;
                V_ICMSMONO := 0;
             END IF;
             IF V_ICMSMONO > 0 THEN
                V_DSINFADICPROD := 'ICMS monofsico cobrado anteriormente: BC '||TRIM(TO_CHAR(ROUND(V_BCMONO, 2), '9999999999999.99'))||
                                   ' (em litros); Alquota: R$ '||TRIM(TO_CHAR(ROUND(C_ITEM.ALIQMONO, 2), '9999999999999.99'))||
                                   '; ICMS mono: R$ '||TRIM(TO_CHAR(ROUND(V_ICMSMONO, 2), '9999999999999.99'));
             END IF;
          END IF;

          UPDATE ITEMPROIMPOS
             SET VRBASECALCIT = V_BCMONO,
                 VRALIQITEM = V_ALIQMONO,
                 VRIMPOSTOIT  = V_ICMSMONO,
                 VRBCMONORET = V_BCMONORET,
                 VRALIQMONORET = V_ALIQMONORET,
                 VRICMSMONORET = V_ICMSMONORET,
                 VRIMPOSTOVISUIT = DECODE(P_IDPERVISIMPSCRE, 'S', V_ICMSMONO,0),
                 VRPREDBCICMSMONO = V_ALIQREDUCAO,
                 VRPERDIFEREIT = V_VRPERDIFERE,
                 VRIMPOSTOOPERAIT = V_ICMSMONOOP,
                 VRIMPOSTODIFERIT = V_ICMSMONODIF
           WHERE (CDFILIAL     = P_CDFILIAL)                   AND
                 (NRLANCTONF   = P_NRLANCTONF)                 AND
                 (NRSEQITPROD  = C_ITEM.NRSEQITPROD) AND
                 (CDIMPOSTO    = C_ITEM.CDIMPOSTO)   AND
                 (NRITPROIMPOS = '1');

          UPDATE ITEMPRODUTO
             SET DSINFADICPROD = SUBSTR(DSINFADICPROD + V_DSINFADICPROD, 1, 500)
           WHERE CDFILIAL = P_CDFILIAL
             AND NRLANCTONF = P_NRLANCTONF
             AND NRSEQITPROD = C_ITEM.NRSEQITPROD;
      END LOOP;
   /*ELSE Entrada*/
   END IF;
END;
/